/*==============================================================================
=                                                                              =
=          FFFFF  RRRR   EEEEE  EEEEE         DDDD    CCC    CCC               =
=          F      R   R  E      E             D   D  C   C  C   C              =
=          F      R   R  E      E             D   D  C      C                  =
=          FFFF   RRRR   EEEE   EEEE   -----  D   D  C      C                  =
=          F      R R    E      E             D   D  C      C                  =
=          F      R  R   E      E             D   D  C   C  C   C              =
=          F      R   R  EEEEE  EEEEE         DDDD    CCC    CCC               =
=                                                                              =
=          FREE-DCC 2017 - version 20180130                                    =
=                                                                              =
=          Programme des centrales FREE-DCC 2017 a base d'Arduino UNO/NANO     =
=          version A: compatible avec les interfaces S88 et Sout de fdcc2010   =
=          version B: petite centrale sans S88 et Sout                         =
=                                                                              =
=          Ulysse Delmas-Begue                                                 =
=          http://udelmas.e-monsite.com                                        =
=          udelmas@laposte.net                                                 =
=                                                                              =
================================================================================

HISTORIQUE:

    2018-01-30: correction sur la commande des aiguillages sur la centrale B avec use_inv_aig_direct_cmd à 1 (merci a Patrick pour avoir souleve le PB)
    2017-06-14: Remise a 0 de CLK avant LOAD S88 pour avoir un chargement synchrone conformement a la norme S88
    2017-06-13: correction sur la centrale 0 toute commande d'aiguillage commandait le 0! (merci a JFC pour avoir souleve le PB)
    2017-06-07: correction d'un bug sur Sout (une ligne de debug trainait, merci a JFC pour avoir souleve le PB)
    2017-05-03: ajout des effets speciaux (pour led et neo)
    2017-05-03: ajout des locos analogiques
    2017-04-28: modification de la lecture des MIN pour suprimer les fausses detections lorsque que le booster LMD18200 est en court-circuit
    2017-04-27: les sevos peuvent maintenant etre  utilises par les aiguillages
    2017-04-14: passage de 16 a 48 pwm/srv par i2c et reglage de la vitesse des servos
    2017-04-11: ajout de l'I2C, de la pwm I2C et des servos I2C
    2017-04-11: ajout des neopixels ! (it desactives durant maj neo, reception rs232 ds un autre buffer)
    2017-04-08: coupure des aiguillages sur la centraleB pendant la lecture du can
    2017-04-07: 1ere release   

    2017-03-28: rajout du support i2c (a tester avec le pca8596 lorsque je l'aurai recu)
    2017-03-27: lecture des min sous it (afin d'en rater le moins possible)   
                rafraichissement 2x plus rapidement des souris pour une meilleure reactivite
    2017-03-24: modification du module min
    2017-03-02: rajout centraleB et lecture min a dcc0/1               
    2017-03-01: protocol 6050 
    2017-03-01: protocol rs232 uu                
    2017-02-28: codage des aiguillages                
    2017-01-26: fonctionement sur plusieurs souris avec selection de la loco a partir des souris
                notes: pas de pb, plusieurs souris peuvent gerer une loc
    2017-01-25: verif ok (sens,vit,fct,au) avec une souris impulsionelle, LMD16200 sous 12V et bb 63000
    2017-01-25: class souris impulsionelles
    2017-01-24: DCC avec FIFO

    2017-01-xx: codage et test
    2016-12-xx: on repense tout
    2015-11-xx: fonctionne mais plus le temps de m'en occuper
    2014-05-xx: essais de generer un signal dcc avec Arduino

TBD:
    - ajouter bmvu (pas de capi pour le moment, ni de daat)
    - suivre les trains
    - ajouter une signalisation plus facile
    - faire une doc sur la signalisation
    - faire une doc sur les differents types d'aiguillages
    - ajouter la conduite automatique respectant la signalisation
    - afficher ds les regu virtuels si utilises par cabines ou script
    - passer des crans au kmph
    - tester sur ArduinoMega
    - tester sur Rpi2 ou 3 (pr voire si c plus rapide)    
    - voir walkaround
    - rajouter les UM  
    - voir passage a 128 crans et 12 fcts
    - verifier code protocols 6050
    - tester S88 et Sout
    - faire modules S88 arduino in16 et in64
    - faire une appli Android
    - ajouter plaques tournantes

EN COURS:
    
VERIFS:
   dcc_it: prends 10us max mais souvent entre 3.5 et 6us
   duree: "1"=58-60us "0"=116-120us
   maj liste dcc 450us
   maj 1 mouse (qui fait rien) 30us
   locos en autonome et pc   
   in 20ms
   out 1.6ms
   led 14ms
   pwm ok
   led ok (teste sur 2x 7219)  cli/pha ok
   can ok; env 100us/canal
   neo ok  1.9ms
   i2c apres optim 8ms pour mettre a jour 16 servos (i2c standard 100KHz. 4us CLK1)
   ok aiguillages maj
   ok min250
   ok min it (dure 5.75us exactement)
   loop 39ms/125 (rs232 change presque rien) typeA
   loop 16ms/125 (rs232 change presque rien) typeB
   majled 14ms->2.5ms(1MHz)->16ms(majin+125KHz)
   test sur nano: souris, min, leds, au, cli, dcc booster, loco : ok      
   sbi/cbi prenent 2 cycles
   servos en mode aiguillage: @tester
   le booster LMD18200 reagit 400 à 500nS apres la commande et met 200ns pour transiter
   loco en analogique a 1KHz avec PWM48 ok
   verifier si const PROGMEM fonctionne reellement ! En attenadant:
   - const byte pca9685_cfg[48]  PROGMEM --> byte
   - const PROGMEM byte io_srv_vit[48] ... (ne pas mettre cmd en PROGMEM) --> byte

NOTES:

trames DCC
vitesse = 0.1.S.V0.V4.V3.V2.V1 
fgroup1 = 1.0.0.FL.F4.F3.F2.F1

Arret d'urgence
adr = 0
vit = B'01000001'

Idle
adr = 0xff
cmd = 0


POSSIBILITEES:

Type A&B
========
DCC          : OUI   (50locos+programation)   (si DCC#, enleve 4 INlocal/MOUSE)
ANALOGIQUE   : OUI   (en utilisant PWM, necessite des relais pour couper DCC et analogique non utilise)
MOUSE        : 10
LED          : 256   (clignotement 1Hz avec choix de phase sur toute les leds, FUTUR: possibilite de definir des effets)
NEO          : 60    (FUTUR: possibilite de definir des effets)
CLI          : 1     (si utilise, enleve NEO)
PC           : OUI   (connection USB, profile serial 115200bps)
AN           : 2     (seulement sur Nano, pas sur UNO)
I2C          : OUI   (enleve 2PWM) 
SERVO (I2C)  : 48    (partage avec PWM-I2C)
PWM   (I2C)  : 48    (partage avec DERVO-I2C)
AIG-SERVO    : 48    (AIG-SERVO + AIG ne peut pas depasser 96)

Type Aonly           Type Bonly
==========           ==========
IN  (busS88) : 256   IN (MIN) : 25
OUT (Sout)   : 64    OUT      : 0
AIG (Sout)   : 96    AIG      : 16
PWM          : 4     PWM      : 2

PINS (Arduino Nano):
|==========|=====================|==============|=======|===========|
|  A&B     |                     | A&B          | Aonly | Bonly     |
|==========|=====================|==============|=======|===========|
|  LI/NEO  |  D13 %USB% D12      |              | DATIN | AIGS3+INE |
|          |  3v3 %%%%% D11~ T2A |              | RSTIN | AIGS2+IND |
|          |  REF %%%%% D10~ T1B |              | PWM51 | AIGS1+INC |
|      DCC |   A0 %%%%% D9~ T1A  |              | PWM50 | AIGS0+INB |
| DCC#/IN1 |   A1 %%%%% D8       |              | LDIN  | AIGDR+INA |
|      IN2 |   A2 %%%%% D7       |              | LDOUT | AIGGO     |
|      IN3 |   A3 %%%%% D6~ T0A  | PWM49/SDA    |       |           |
|      IN4 |   A4 %%%%% D5~ T0B  | PWM48/SCK    |       |           |
|      IN5 |   A5 %%%%% D4       |      LDLED   |       |           |
|      AN0 |   A6 %%%%% D3~ T2B  | INSB+DAT     |       |           |
|      AN1 |   A7 %%%%% D2       | INSA+CLK     |       |           |
|          |   5V %%%%% GND      |              |       |           |
|          |  RST %%%%% RST      |              |       |           |
|          |  GND %%%%% RX       | Arduino-->PC |       |           |
|          |  VIN %%%%% TX       | Arduino<--PC |       |           |
|==========|=====================|==============|=======|===========|

PINS (Arduino Uno (sur arduino UNO, manque A6&A7)
|==========|=====================|==============|=======|===========|
|  A&B     |                     | A&B          | Aonly | Bonly     |
|==========|=====================|==============|=======|===========|
|          |    x %USB% AREF     |              |       |           |
|          |    x %%%%% GND      |              |       |           |
|          |    x %%%%% D13      | CLI/NEO      |       |           |
|          |IOREF %%%%% D12      |              | DATIN | AIGS3+INE |
|          |  RST %%%%% D11~ T2A |              | RSTIN | AIGS2+IND |
|          |  3v3 %%%%% D10~ T1B |              | PWM51  | AIGS1+INC |
|          |   5v %%%%% D9~  T1A |              | PWM50 | AIGS0+INB |
|          |  GND %%%%% D8       |              | LDIN  | AIGDR+INA |
|          |  GND %%%%% x        |              |       |           |
|          |  VIN %%%%% D7       |              | LDOUT | AIGGO     |
|          |    x %%%%% D6~ T0A  |  PWM49/SCK   |       |           |
|     DCC  |   A0 %%%%% D5~ T0B  |  PWM48/SDA   |       |           |
| DCC#/IN1 |   A1 %%%%% D4       |      LDLED   |       |           |
|      IN2 |   A2 %%%%% D3~ T2B  | INSB+DAT     |       |           |
|      IN3 |   A3 %%%%% D2       | INSA+CLK     |       |           |
|      IN4 |   A4 %%%%% RX       | Arduino-->PC |       |           |
|      IN5 |   A5 %%%%% TX       | Arduino<--PC |       |           |
|==========|=====================|==============|=======|===========|

    
QUELQUES NOTES SUR LA PWM POUR ARDUINO UNO R3:

T0A --> PWM D6
T0B --> PWM D5
T1A --> PWM D9
T1B --> PWM D10
T2A --> PWM D11
T2B --> PWM D3
 
analogWrite(pin, value);  // 0->0% 1->2/256% 255->256/256%
T0 aussi utilise pour millis ... (pas de pb pour utiliser pwm en //)
T2 peut etre utilise par tone (dans ce cas pas de pwm avec T2)
    tone(pin,value,[duration ms])  //31Hz-65kHz
    notone()
T1 peut etre utilise par servo (dans ce cas pas de pwm avec T1) servos sur 12 pins 2-13
    #include <Servo.h>
    Servo aServo  or   Servo tServo[12]
    aServo.attach(pin_number)
    aServo.writeMicroseconds(uS) // aServo.write(0-180)
    plus besoin d'utiliser refresh

bb66000 adr6
bb66000 adr7
bb67000 adr8
        adr9
bb63000 adr10
        adr11
ead     adr12
eat     adr13

I2C:
GPIO 23017        circuit DIL, 3 euros sur adafruit
MLI  PCA9685      16chMLI res4096(12bits) F24->1526Hz    --> carte complete pour 16servos from 7€ sur amazon   (le circuit n'existe pas en format DIL)

===========================================================================*/

/*--------------------------------------------------------------------------
0. Configuration de la centrale
--------------------------------------------------------------------------*/

// Type de centrale
#define use_centraleA 1   // 1 = centrale de type A (0 sinon)
#define use_centraleB 0   // 1 = centrale de type B (0 sinon)

// Numero de la centrale (si plusieurs centrales sont utilisees)
// normalement seulement la 0 genere le signal DCC
#define num_centrale 0

// DCC # (utilise DCC#)
#define use_DCCB 0        //0=PORT_A1->IN_4 / 1=PORT_A1->DCC#

// CLI (utilise CLI)
#define use_CLI  1        //0=NEO / 1=CLI

// adresse des locos des souris a l'initialisation (1-50  0=aucune locomotive selectionee)
#define MOUSE_0_ADR 10
#define MOUSE_1_ADR 0
#define MOUSE_2_ADR 0
#define MOUSE_3_ADR 0
#define MOUSE_4_ADR 0
#define MOUSE_5_ADR 0
#define MOUSE_6_ADR 0
#define MOUSE_7_ADR 0
#define MOUSE_8_ADR 0
#define MOUSE_9_ADR 0

// locomotives analogiques
// La fonction add_alim_analog(adr, pwm_vit, pwm_dir, pwm_cran1, pwm_cran28)
// permet de remplacer une loco numérique par une alimentaion analogique
// Pour le système, l'alimentation analogique obeit aux ordres de la loco numérique associée !
// adr        = adresse de la loco numérique associée (1-50). Si adr==0 l'alimentation analogique n'est pas utilisée.
// pwm_vit    = numéro de la broche pwm gérant la vitesse (0-51)
// pwm_dir    = numéro de la sortie pwm gérant le sens    (0-51). Il est dommage d'utiliser une sortie pwm pour le sens mais ca simplifie !
// pwm_cran1  = valeur de la pwm (0-255) pour le cran numérique  1 (la locomotive doit démarer)
// pwm_cran28 = valeur de la pwm (0-255) pour le cran numérique 28 (la locomotive doit démarer)
// Ex: add_alim_analog(50, 48, 49, 25, 255); \ (la loco numerique 50 est remplacee par l'alimentation "analogique" vit=pwm48 sens=pwm49 cran1=25/255 cran28=255/255
// vous pouvez définir jusqu'a 5 alimentations analogiques
#define CONFIG_ALIM_ANALOG \
add_alim_analog( 0,  0,  0, 25, 255); \
add_alim_analog( 0,  0,  0, 25, 255); \
add_alim_analog( 0,  0,  0, 25, 255); \
add_alim_analog( 0,  0,  0, 25, 255); \
add_alim_analog( 0,  0,  0, 25, 255); \

// Protocol de communication centrale <--> PC
// 1=utilisation du protocol (0=non). Seul un protocol peut être utilise !
#define use_UU        1  // 1 = protocol UU
#define use_6050      0  // 1 = protocol 6050 Marklin
#define use_DBG_mouse 0  // 1 = debug mouse
//vitesse de communication parmi:
#define RS232_SPEED 115200  // 1200, 2400, 4800, 9600, 19200, 115200bps  

// constantes des modules sur le bus Sout (ne pas modifier)
#define SOUT_OUT0_7   0
#define SOUT_OUT8_15  1
#define SOUT_OUT16_23 2
#define SOUT_OUT24_31 3
#define SOUT_OUT32_39 4
#define SOUT_OUT40_47 5
#define SOUT_OUT48_55 6
#define SOUT_OUT56_63 7
#define SOUT_AIG0_47  8
#define SOUT_AIG48_95 9
#define SOUT_END     10
//definir les modules OUT et AIG sur le bus Sout du plus proche au plus lointain de la centrale
//(sans importance pour centrale type B)
unsigned char sout_config[] = { SOUT_AIG0_47, SOUT_OUT0_7, SOUT_OUT8_15, SOUT_OUT16_23, SOUT_OUT24_31, SOUT_AIG48_95,  SOUT_OUT32_39, SOUT_OUT40_47, SOUT_OUT48_55, SOUT_OUT56_63, SOUT_END };

// AIG
    //constantes aig (ne pas modifier)
    #define AIG_SOUT_DIRECT 0  //centraleA: aiguillage sur bus Sout, centraleB: sorties directes
    #define AIG_SRV         1  //centraleA ou B: servos
    // impulsion (AIG_PULSE_X desactive l'aiguillage). 
    #define AIG_PULSE_X      0 // aiguillage non utilise
    #define AIG_PULSE_125ms  1
    #define AIG_PULSE_250ms  2
    #define AIG_PULSE_500ms  3
    #define AIG_PULSE_1s     4
    #define AIG_PULSE_2s     5
    #define AIG_PULSE_5s     6 
    #define AIG_PULSE_10s    7
    // inversion
    #define AIG_NORMAL       0
    #define AIG_INV          1
    // position demandee a l'init
    #define AIG_DIR          0
    #define AIG_DEV          1
    // macro
    #define config_aig(num_aig, module, num_aig_du_module, inv, pulse, cmd)  aig_data[num_aig] = (((module & 2) << 14) + (num_aig_du_module << 8) + (inv << 7) + (pulse << 4) + ((module & 1) << 3) + cmd)

// definir pour chacun des aiguillages 0-95, le type de module, le numero de l'aiguillage sur ce module, l'invesion, la duree de l'impulsion ou la non utilisation, la commande a l'init
// tout aiguillage non decalre ne sera pas utilise
#define AIG_SPECIFIC_INIT \
    config_aig(  0, AIG_SOUT_DIRECT,  0, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig(  1, AIG_SOUT_DIRECT,  1, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig(  2, AIG_SOUT_DIRECT,  2, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig(  3, AIG_SOUT_DIRECT,  3, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig(  4, AIG_SOUT_DIRECT,  4, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig(  5, AIG_SOUT_DIRECT,  5, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig(  6, AIG_SOUT_DIRECT,  6, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig(  7, AIG_SOUT_DIRECT,  7, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig(  8, AIG_SOUT_DIRECT,  8, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig(  9, AIG_SOUT_DIRECT,  9, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig( 10, AIG_SOUT_DIRECT, 10, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig( 11, AIG_SOUT_DIRECT, 11, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig( 12, AIG_SOUT_DIRECT, 12, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig( 13, AIG_SOUT_DIRECT, 13, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig( 14, AIG_SOUT_DIRECT, 14, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \
    config_aig( 15, AIG_SOUT_DIRECT, 15, AIG_NORMAL, AIG_PULSE_500ms, AIG_DIR); \

// Cas particulier des servos:
// - la duree de l'impulsion n'est pas valable pour les servos
//   (mais AIG_PULSE_X desactive quand meme l'aiguillage)
// - Utiliser io_srv_vit (pour la vitesse de deplacement des lames)
// - io_srv_pos0 pour la position directe
// - io_srv_pos1 pour la position deviee
// - io_srv_cmd  pour la position a l'init avant l'init des aiguillages
//   (normalmeent, on mettra la meme que pos0)
// - inv n'a pas d'impact

// inversion la commande des aiguillages directs pour la centrale B
// 1 = pour les modules de relais qui collent à l'etat bas au lieu de l'etat haut
#define use_inv_aig_direct_cmd 0 

// I2C
#define use_i2c 0  // 0=PWM48&49 / 1=I2C

// PCA9685
// Les 3 PCA9685 sont maintenant automatiquement detectes
// - pca9685_0 adr0(A5=0 A4=0 A3=0 A2=0 A1=0 A0=0)
// - pca9685_1 adr1(A5=0 A4=0 A3=0 A2=0 A1=0 A0=1)
// - pca9685_2 adr2(A5=0 A4=0 A3=0 A2=0 A1=1 A0=0)

#define SRV 0
#define PWM 1 
// choisir entre mode SRV ou PWM  (pca9685_0:0-15, pca9685_1:16-31, pca9685_2:32-47)
// numéro de la pwm ou du servo          0    1    2    3    4    5    6    7       8    9   10   11   12   13   14   15      16   17   18   19   20   21   22   23      24   25   26   27   28   29   30   31      32   33   34   35   36   37   38   39      40   41   42   43   44   45   46   47  
              byte pca9685_cfg[48] = { SRV, SRV, SRV, SRV, SRV, SRV, SRV, SRV,    SRV, SRV, SRV, SRV, PWM, PWM, PWM, PWM,    SRV, SRV, SRV, SRV, SRV, SRV, SRV, SRV,    SRV, SRV, SRV, SRV, SRV, SRV, SRV, SRV,    SRV, SRV, SRV, SRV, SRV, SRV, SRV, SRV,    SRV, SRV, SRV, SRV, SRV, SRV, SRV, SRV,};  

// vitesse des servomoteurs (1 =env 1deg/sec) choisir entre 1 (tres lent) et 255 (tres rapide)
// position des servomoteurs a l'initialisation (le PC va surement la changer !) //*10us -> 150=1500us=1.5ms=neutre
// pos0 et pos1 si le servo est utilise par les aiguillages
// io_srv_aig a 1 indique que le servo est utilise pour un aiguillage et ne repondra pas a un ordre de mise a jour srv par la liaison serie
// io_srv_aig a 0 indique que le servo n'est utilise pour un aiguillage et ne repondra a un ordre de mise a jour d'aiguillage
// numéro du servo                       0    1    2    3    4    5    6    7       8    9   10   11   12   13   14   15     16   17   18   19   20   21   22   23      24   25   26   27   28   29   30   31      32   33   34   35   36   37   38   39     40   41   42   43   44   45   46   47  
              byte io_srv_vit[48]  = {   1,   2,   3,   4,   5,  10,  20,  50,    100, 200, 250,  50,  50,  50,  50,  50,    50,  50,  50,  50,  50,  50,  50,  50,     50,  50,  50,  50,  50,  50,  50,  50,     50,  50,  50,  50,  50,  50,  50,  50,    50,  50,  50,  50,  50,  50,  50,  50  };
              byte io_srv_cmd[48]  = { 150, 150, 150, 150, 150, 150, 150, 150,    150, 150, 150, 150, 150, 150, 150, 150,    150, 150, 150, 150, 150, 150, 150, 150,    150, 150, 150, 150, 150, 150, 150, 150,    150, 150, 150, 150, 150, 150, 150, 150,   150, 150, 150, 150, 150, 150, 150, 150 };  
              byte io_srv_pos0[48] = { 100, 100, 100, 100, 100, 100, 100, 100,    100, 100, 100, 100, 100, 100, 100, 100,    100, 100, 100, 100, 100, 100, 100, 100,    100, 100, 100, 100, 100, 100, 100, 100,    100, 100, 100, 100, 100, 100, 100, 100,   100, 100, 100, 100, 100, 100, 100, 100 };  
              byte io_srv_pos1[48] = { 200, 200, 200, 200, 200, 200, 200, 200,    200, 200, 200, 200, 200, 200, 200, 200,    200, 200, 200, 200, 200, 200, 200, 200,    200, 200, 200, 200, 200, 200, 200, 200,    200, 200, 200, 200, 200, 200, 200, 200,   200, 200, 200, 200, 200, 200, 200, 200 };  
              byte io_srv_aig[48]  = {   0,   0,   0,   0,   0,   0,   0,   0,      0,   0,   0,   0,   0,   0,   0,   0,      0,   0,   0,   0,   0,   0,   0,   0,      0,   0,   0,   0,   0,   0,   0,   0,      0,   0,   0,   0,   0,   0,   0,   0,     0,   0,   0,   0,   0,   0,   0,   0 };  



/*--------------------------------------------------------------------------
1. Gestion du DCC
--------------------------------------------------------------------------*/
#include <avr/io.h>
#include <avr/interrupt.h>
#define NOP __asm__ __volatile__ ("nop\n\t")    //62.5ns

byte  cpt_125ms;

/* variables DCC */
// ne pas oublier d'utiliser volatile si une variable est partagee entre loop et it

#define DCC_CH_STOP  51   //valid 1-50

// peut etre changer a terme: vit : F0.x.SENS.v4.v3.v2.v1.v0 / sens: x.x.x.x.f4.f3.f2.f1
//dcc_ch[i].vit = 0x60;  // vitesse = U.1.S.V0.V4.V3.V2.V1 = vitesse nulle. U est mis a jour chaque fois que vit est updater, a remplacer par 0 par la cmd
//dcc_ch[i].fct = 0x80;  // fgroup1 = 1.0.0.FL.F4.F3.F2.F1 = aucune fct
struct ch
{
    unsigned char vit;
    unsigned char fct;
};
volatile ch dcc_ch[DCC_CH_STOP];   //0=not used -- 50 

volatile byte dcc_liste[10];   //9 places largement suffisant pour un appele tous les 125ms car 20ms pr vit+fct
volatile byte dcc_liste_wr=0;  //indice d'ecriture (mis a jour par bcl)
volatile byte dcc_liste_rd=0;  //indice de lecture (mis a jour par it dcc)
byte dcc_adr1=1;               //indice loco en mouvement ou updatee
byte dcc_adr2=1;               //indice de toutes les locos
byte dcc_tx_adr2=0;

#define DCC_PHASE_0_L   0 // 0: __##
#define DCC_PHASE_0_L2  1
#define DCC_PHASE_0_H   2
#define DCC_PHASE_0_H2  3
#define DCC_PHASE_0_NEW 4            // pour calcul du prochain 1
#define DCC_PHASE_1_L   5 // 1: _#
#define DCC_PHASE_1_H   6
#define DCC_PHASE_1_NEW 7            // pour calcul du prochain 0

unsigned char dcc_next_port_val = 0;
unsigned char dcc_phase = DCC_PHASE_0_L;
unsigned char dcc_val = 0;
unsigned char dcc_val8 = 0;
unsigned char dcc_cpt_bit = 0;
unsigned char dcc_cpt_field = 0;
unsigned char dcc_bytes[4]; // 0-111111111-0-adr-0-cmd-0-xor-1

volatile unsigned char dcc_au    = 0; 
unsigned char loc_adr   = 0;  
unsigned char dcc_tx_fct = 0;
volatile byte dcc_var_stop = 0;

volatile unsigned char dcc_prog = 0; //mettre a 1 pour initier la prog (se remet a 0 automatiquement)
volatile unsigned char cv_dat = 0;   //0-255     //cv_adr 1-1024
volatile unsigned char cv_pag = 0;   //1-255-0
volatile unsigned char cv_reg = 0;   //0-3

#define DCC_PROG_FRAME_IDLE  0
#define DCC_PROG_FRAME_RESET 1
#define DCC_PROG_FRAME_PAGE  2
#define DCC_PROG_FRAME_DAT   3
//22x idle 3x reset 6x page 10x reset 6x dat 10x reset 0xidle
unsigned char dcc_prog_seq[] = { \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
\
DCC_PROG_FRAME_PAGE, \
DCC_PROG_FRAME_PAGE, \
DCC_PROG_FRAME_PAGE, \
DCC_PROG_FRAME_PAGE, \
DCC_PROG_FRAME_PAGE, \
DCC_PROG_FRAME_PAGE, \
\
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
\
DCC_PROG_FRAME_DAT, \
DCC_PROG_FRAME_DAT, \
DCC_PROG_FRAME_DAT, \
DCC_PROG_FRAME_DAT, \
DCC_PROG_FRAME_DAT, \
DCC_PROG_FRAME_DAT, \
\
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
DCC_PROG_FRAME_RESET, \
};
#define PROG_SEQ_SIZE 35

int seq_ind = 0;
unsigned char preambule_len = 10;


// 0. Lecture des mi sous IT

volatile byte io_in[32];          // 256 entrees (definit ici car utilise sous it pour les min)
volatile byte rd_min_it_enable=1; // activation des min (0 pour desactiver lors de la lecture can)
byte rd_min_it_mask = 1;          //mask de colonne
byte rd_min_it_nbrd = 3;          //decompteur pour lire 3 fois chaque entree (afin de lire au moins sur un niveau H et un niveau L)
byte rd_min_it_num  = 0;          //index ds le tableau des io_inmem

inline void rd_min_it(void)
{  
   if(rd_min_it_enable)
   {
       byte savePORTB; //D13-D12-D11-D10-D9-D8     D12=AIGS3 D11=AIGS2 D10=AIGS1 D9=AIGS0 D8=AIGDR
       byte savePORTD; //D7-D0                     D7=AIGGO
       byte lect_or;
       
       // sauver aigs
       savePORTB = PORTB;
       savePORTD = PORTD;

       // desactivation des aiguillages
       #if use_inv_aig_direct_cmd == 0
           __asm__ __volatile__ ("cbi 11,7\n\t"); //equivalent a digitalWrite(PIN_AIGGO , LOW); mais en bcp plus rapide
       #else
           __asm__ __volatile__ ("sbi 11,7\n\t");
       #endif    

       // mise a 0 de seulement la bonne colonne
       PORTB|=0x1f;
       PORTB^=rd_min_it_mask;  //plus rapide que: PORTB^=1<<rd_min_it_num;

       // on atends un peu avant de lire (2us) pour laisser le temps aux optocoupleurs lents de reagir
       NOP; NOP; NOP; NOP; NOP; NOP; NOP; NOP; // 1us
       NOP; NOP; NOP; NOP; NOP; NOP; NOP; NOP; // 1us

       // lecture
       // la lecture en 3 fois (espacement 125ns) supprime les fausse detections dues a aux couplages electromagnetiques
       // commme lorsque le booster est en court-circuit. Par exemple le booster LMd18200 essaye de retablir le courant 
       // toute les 2us, s'en suit une grosse perturbation de 20 à 100nS qui perturbe les entrées par couplage électro-magnétique.
       // Pour qu'une detection soit valide, elle doit etre valide durant les 3 lectures.       
       lect_or = PINC;   
       lect_or |= PINC;
       lect_or |= PINC;
       io_in[rd_min_it_num] |= ((lect_or ^ 0xff) & 0x3e);  // actif a l'etat bas // seuls 5 bits nous interesse (possible de gagner cette instructione)

       // restauration et reactivation des aiguillages
       PORTB = savePORTB;
       if(savePORTD&0x80) { __asm__ __volatile__ ("sbi 11,7\n\t"); }
       else               { __asm__ __volatile__ ("cbi 11,7\n\t"); }

       // prochain indice
       rd_min_it_nbrd--;
       if(rd_min_it_nbrd==0)
       {
           rd_min_it_nbrd=3;
           rd_min_it_num+=1; rd_min_it_mask=rd_min_it_mask<<1;
           if(rd_min_it_num==5) { rd_min_it_num=0; rd_min_it_mask=1; }
       }
   }       
}

/* 1. Fonctions DCC sous IT */

inline void compute_new_frame_prog(void)
{
    dcc_bytes[0] = 0xff;
    preambule_len = 22;

    switch(dcc_prog_seq[seq_ind])
    {
        case DCC_PROG_FRAME_IDLE:        
                    dcc_bytes[1] = 0xff;
                    dcc_bytes[2] = 0;
                    break;
        case DCC_PROG_FRAME_RESET:        
                    dcc_bytes[1] = 0;
                    dcc_bytes[2] = 0;
                    break;
        case DCC_PROG_FRAME_PAGE:        
                    dcc_bytes[1] = 0x7D;  //0111CRRR C=1=WR RRR=5=page
                    dcc_bytes[2] = cv_pag;
                    break;
        case DCC_PROG_FRAME_DAT:        
                    dcc_bytes[1] = (unsigned char)0x78 + cv_reg;  //0111CRRR C=1=WR RRR=0(cv1),1(cv2),2(cv3),3(cv4) ...
                    dcc_bytes[2] = cv_dat;
                    break;
    }

    dcc_bytes[3] = dcc_bytes[1] ^ dcc_bytes[2]; 
              
    seq_ind++;
    if(seq_ind == PROG_SEQ_SIZE) 
    {
        dcc_prog--;
        seq_ind = 0; 
    }
}

inline void compute_new_frame(void)
{
    byte rd;
      
     dcc_bytes[0] = 0xff;
     preambule_len = 14;
                
    if(dcc_au) // Arret d'urgence
    {
        dcc_bytes[1] = 0;    // broadcast: toutes les locos
        dcc_bytes[2] = 0x41; // arret d'urgence
    }

    else if(dcc_tx_fct)
    {
        dcc_bytes[1] = loc_adr;
        dcc_bytes[2] = dcc_ch[loc_adr].fct;                                       
        dcc_tx_fct = 0;
    }

    else
    {
        rd=dcc_liste_rd;
        if(dcc_liste_wr==rd) //fifo vide
        {
            dcc_bytes[1] = 0xff; //bourrage
            dcc_bytes[2] = 0;        
        }
        else
        {
            loc_adr = dcc_liste[rd];
            rd++; if(rd==10) rd=0; 
            dcc_liste_rd=rd;
            dcc_bytes[1] = loc_adr;
            dcc_ch[loc_adr].vit&=0x7f;          //clr update bit (also in array)
            dcc_bytes[2] = dcc_ch[loc_adr].vit;                      
            dcc_tx_fct = 1;
            //Serial.print("a"); Serial.println(loc_adr);
        }
    }

    dcc_bytes[3] = dcc_bytes[1] ^ dcc_bytes[2];
}

inline void dcc_it(void)
{
    // Mise a jour du port avec l'etat DCC calcul precedement
    // Fait ici pour avoir un timing precis
    //PORTC = port_mouse | dcc_next_port_val;
    ////PORTC = dcc_next_port_val;
    if(dcc_next_port_val)
    {
#if use_DCCB == 1
        __asm__ __volatile__ ("cbi 8,1\n\t");  //PORTC=8 , bit1  //DCCB
#endif
        __asm__ __volatile__ ("sbi 8,0\n\t");  //PORTC=8 , bit0  //DCC
    }        
    else
    {        
        __asm__ __volatile__ ("cbi 8,0\n\t");  //PORTC=8 , bit0  //DCC
#if use_DCCB == 1
        __asm__ __volatile__ ("sbi 8,1\n\t");  //PORTC=8 , bit1  //DCCB
#endif
    }        

    // Calcul du prochain etat
    dcc_phase++;
    if(dcc_phase == DCC_PHASE_0_H || dcc_phase == DCC_PHASE_1_H) dcc_next_port_val = 0x1;

    if(dcc_phase == DCC_PHASE_0_NEW || dcc_phase == DCC_PHASE_1_NEW)
    {
        // calcul du prochain bit
        if(dcc_cpt_bit==0)
        {
            if(dcc_cpt_field == 0)
            {
                dcc_val = 1;   //pr transmettre 1 final (entre les 2 trames)

                // calcul de la nouvelle trame
                if(dcc_prog == 0)
                    compute_new_frame();
                else
                    compute_new_frame_prog();

                dcc_val8=0xff;
                dcc_cpt_bit = preambule_len;
                dcc_cpt_field = 1;
            }
            else
            {
                dcc_val = 0;  //inter trames
                dcc_cpt_bit = 8;
                dcc_val8 = dcc_bytes[dcc_cpt_field]; //0=premabule; 1=adr; 2=cmd; 3=xor
                dcc_cpt_field++;
                if(dcc_cpt_field == 4) dcc_cpt_field = 0;
            }
        }
        else
        {
            if(dcc_val8 & 0x80) dcc_val = 1; else dcc_val = 0;   //MSB transmit first
            dcc_val8 = (dcc_val8 << 1) | 1;  // |1 pour les preambules > 10 bits et apres CC 
            dcc_cpt_bit--;

            if(dcc_var_stop == 1 && dcc_cpt_field == 1 && dcc_cpt_bit == 10) dcc_var_stop = 2;
        }

        if(dcc_val) dcc_phase = DCC_PHASE_1_L; else dcc_phase = DCC_PHASE_0_L;
        ////dcc_next_port_val = 0x20;
        dcc_next_port_val = 0;
   } 

   // lecture des MIN
#if use_centraleB == 1
    rd_min_it();    
#endif    
}


/* 2. Gestion du timer 2 (pour le DCC) */

// timer 2 interrupt (58us)
// init du timer pour generer une IT toute les 58us
//  Prescaler: set to divide-by-8 (B'010)  --> 16MHz/8 = 2Mhz --> inc toutes les 0.5us
//  Compare target: 58us / ( 1 / ( 16MHz/8) ) = 116
//#define TIMER2_TARGET 114   //on mesure 60us
#define TIMER2_TARGET 110     //on mesure 58us
//#define TIMER2_TARGET 106   //on mesure 56us

unsigned short cpt58 = 0;
//volatile byte flag_125ms = 0;
volatile byte flag_62ms5 = 0;
byte in_it = 0;
volatile byte err_it = 0;

ISR( TIMER2_COMPA_vect ){
  TCNT2 = 0; // Reset Timer2 counter ...
  //OCR2A += TIMER2_TARGET;  //autre technique a essyer mais emble ne pas marcher
  
  if(in_it) err_it++;
  
  dcc_it();
  
  cpt58++;
  //if(cpt58 == (125000 / 58)) { cpt58 = 0; flag_125ms = 1; /*Serial.print("*");*/}
  if(cpt58 == (62500 / 58)) { cpt58 = 0; flag_62ms5 = 1; /*Serial.print("*");*/}
  in_it = 0;
}

void timer_init() 
{
    // Set prescaler to div-by-8
    bitClear(TCCR2B, CS22);
    bitSet(TCCR2B, CS21);
    bitClear(TCCR2B, CS20);
  
    // Set counter target
    OCR2A = TIMER2_TARGET;
    
    // Enable Timer2 interrupt
    bitSet(TIMSK2, OCIE2A); 
}

//bitSet(TIMSK0, TOIE0);
//bitClear(TIMSK0, TOIE0);  desactive IT debordement timer 0 (pour ne pas etre embete par millis)

//UCSR0B
//- UDRIE0 = tx buffer empty
//- TXCIE0 = tx done
//- RXCIE0 = data rx in register

/* 3. Fonctions DCC hors IT */
//class juste pour les fonctions afin d'avoir des appels clairs
//(tout le reste est hors class pour gagner en performances)

class DCC   
{
    public:
        DCC(void) {}  // constructeur vide

        void init(void);
        void sstop(void);
        void restart(void);
        void low(void);
        void high(void);
    
        void maj_dcc_liste(void);
        void prog_cv(unsigned int cv_adr, unsigned char dat);
        void update_loc_sens_vit_fct(unsigned char loc, unsigned char sens, unsigned char vit, unsigned char f43210);
    
        byte get_vit(byte loc);
        byte get_sens(byte loc);
        byte get_fct43210(byte loc);
        void update_loc_sens(unsigned char loc, unsigned char sens);
        void update_loc_vit(unsigned char loc, unsigned char vit);
        void update_loc_fct(unsigned char loc, unsigned char f43210);    
};

void DCC::init(void)
{
     byte i;
     
    timer_init();

    for(i=1; i<DCC_CH_STOP; i++)  //valid 1-50
    {
        dcc_ch[i].vit = 0x60;
        dcc_ch[i].fct = 0x80; 
        //update_loc_sens_vit(i,1,0,1);
    }
    dcc_au=0;    //UU: choisir
}

void DCC::sstop(void)
{
    dcc_var_stop = 1;
    while(dcc_var_stop != 2) { }
    bitClear(TIMSK2, OCIE2A); 
}

void DCC::restart(void)
{
    dcc_var_stop = 0;
    dcc_cpt_bit = preambule_len;
    bitSet(TIMSK2, OCIE2A); 
}

void DCC::low(void)   // a faire en stop
{
    //PORTC = 0x20;
    __asm__ __volatile__ ("cbi 8,0\n\t");  //PORTC=8 , bit1  //DCC
    #if use_DCCB == 1
    __asm__ __volatile__ ("sbi 8,5\n\t");  //PORTC=8 , bit5  //DCCB
    #endif
}

void DCC::high(void)  // a faire en stop
{
    //PORTC = 0x1;
    #if use_DCCB == 1
    __asm__ __volatile__ ("cbi 8,5\n\t");  //PORTC=8 , bit5  //DCCB
    #endif
    __asm__ __volatile__ ("sbi 8,0\n\t");  //PORTC=8 , bit1  //DCC
}

void DCC::maj_dcc_liste(void)   //ajoute dans la liste dcc les loco a mettre a jours
{
    byte wr;    //wr temporaire pour modifier celui partage une seule fois
    byte wr2;
    byte dcc_adr1_dcpt;
    byte vit;
    
    dcc_adr1_dcpt=DCC_CH_STOP-1;   //51 1-50
    wr=dcc_liste_wr;

    ////Serial.println("wr#");
    
    while(1)
    {
        wr2=wr+1; if(wr2>=10) wr2=0;
        if(wr2==dcc_liste_rd) break;  //plus de place ds la liste         
      
        if(dcc_tx_adr2)
        {
            ////Serial.print("wr2="); Serial.println(dcc_adr2);   
            dcc_liste[wr]=dcc_adr2; wr=wr2;
            dcc_tx_adr2=0; dcc_adr2++;
            if(dcc_adr2==DCC_CH_STOP) dcc_adr2=1;
            continue;   
        }
  
        if(dcc_adr1_dcpt==0) break;
  
        vit=dcc_ch[dcc_adr1].vit;
        if(vit & 0x9f) //en mouvement ou updatee
        {
            ////Serial.print("wr1="); Serial.println(dcc_adr1);   
            dcc_liste[wr]=dcc_adr1; wr=wr2;
        }
        dcc_adr1++; dcc_adr1_dcpt--;
        if(dcc_adr1==DCC_CH_STOP)
        {
            dcc_adr1=1;     
            dcc_tx_adr2=1;      
        }
    }
    
    dcc_liste_wr = wr;   //mise a jour de l'index d'ecriture (pour que dcc_it l'utilise)
}

void DCC::prog_cv(unsigned int cv_adr, unsigned char dat)
{
    cv_pag = ((cv_adr-1)/4)+1;
    cv_reg = (cv_adr-1)&3;
    cv_dat = dat;
    dcc_prog = 1;
}

byte DCC::get_vit(byte loc)
{
    unsigned char data;

    if(loc==0 || loc>=DCC_CH_STOP) return 0;
    data = dcc_ch[loc].vit;
    data = data << 1;
    if(data & 0x20) data |=1;
    data &= 0x1f;
    if(data>=4) data-=3; else data=0;
    return data;
}

byte DCC::get_sens(byte loc)
{
    if(loc==0 || loc>=DCC_CH_STOP) return 0;
    if(dcc_ch[loc].vit & 0x20) return 1;
    return 0;
}

byte DCC::get_fct43210(byte loc)
{
    byte data;
    
    if(loc==0 || loc>=DCC_CH_STOP) return 0;
    data = dcc_ch[loc].fct;
    data = data << 1;
    if(data & 0x20) data |=1;
    data &= 0x1f;
    return data;
}

// sens 1=AV, 0=AR
// vit 0--28
void DCC::update_loc_sens_vit_fct(unsigned char loc, unsigned char sens, unsigned char vit, unsigned char f43210)
{
    unsigned char data;
    unsigned char loc_vit;
    unsigned char loc_fct;
    unsigned char same;
    
    if(loc==0 || loc>=DCC_CH_STOP)
        return;

    // 0 1 D V0 V4 V3 V2 V1
    // 0 1 x  x  0  0  0  0  = cran0
    // 0 1 x  x  0  0  0  1  = AU
    // 0 1 x  0  0  0  1  0  = cran1
    // ...
    // 0 1 x  1  1  1  1  1  = cran28
    data = 0x40;  
    if(sens)
    {
        data |= 0x20;
    }    
    if(vit >= 1)
    {
        data |= ((vit + 3) >> 1);
        if((vit & 1) == 0)
            data |= 0x10;
    }
    loc_vit = data;
    #if use_DBG_mouse == 1
        Serial.print("locvit="); Serial.println(loc_vit);   
    #endif        

    // 1 0 0 F0 F4 F3 F2 F1
    data = 0x80;
    if(f43210 & 1)
        data |= 0x10;
    data |= (f43210 >> 1);
    loc_fct = data;

    same = 1;
    #if use_DBG_mouse == 1     
        Serial.print("dcc_ch["); Serial.print(loc); Serial.print("].vit="); Serial.println(dcc_ch[loc].vit);   
    #endif
    if((dcc_ch[loc].vit&0x7f) != loc_vit)
        same = 0;
    if(dcc_ch[loc].fct!= loc_fct)
        same = 0;
    if(same==0)
    {
        dcc_ch[loc].fct=loc_fct;          
        dcc_ch[loc].vit=loc_vit|0x80;  //update flag          
    }   
}

void DCC::update_loc_sens(unsigned char loc, unsigned char sens)
{
    byte data, mask;
    
    if(loc==0 || loc>=DCC_CH_STOP)
        return;

    data = dcc_ch[loc].vit;
    if(sens) mask=0x20; else mask=0;
    if((data ^ mask) & 0x20) //si different
    {
      dcc_ch[loc].vit ^=0x20;
      dcc_ch[loc].vit |=0x80;  //update flag
    }
   
}

void DCC::update_loc_vit(unsigned char loc, unsigned char vit)
{
    unsigned char data;
    unsigned char loc_vit;
    
    if(loc==0 || loc>=DCC_CH_STOP)
        return;

    data = 0;  
    if(vit >= 1)
    {
        data |= ((vit + 3) >> 1);
        if((vit & 1) == 0)
            data |= 0x10;
    }

    loc_vit = dcc_ch[loc].vit;
    if((loc_vit ^ data) & 0x1f) //differents
    {
      loc_vit &= 0xe0;  //01Dxxxxx
      loc_vit |= data;  //01DVVVVV
      loc_vit |= 0x80;  //update flag 11DVVVVV
      dcc_ch[loc].vit=loc_vit;          
    }   
}

void DCC::update_loc_fct(unsigned char loc, unsigned char f43210)
{
    unsigned char data;
    unsigned char loc_fct;
    
    if(loc==0 || loc>=DCC_CH_STOP)
        return;

    // 1 0 0 F0 F4 F3 F2 F1
    data = 0x80;
    if(f43210 & 1)
        data |= 0x10;
    data |= (f43210 >> 1);
    
    loc_fct = dcc_ch[loc].fct;
    if(data != loc_fct)
    {
        dcc_ch[loc].fct  = data;          
        dcc_ch[loc].vit |= 0x80;  //update flag          
    }
}

DCC dcc;



//------------------------------------------------------------------------------
// CAN
//------------------------------------------------------------------------------

  /*
    Addr    Name     Bit7   Bit6   Bit5   Bit4   Bit3   Bit2   Bit1   Bit0
    ...
    0x03   PINB     PINB7  PINB6  PINB5  PINB4  PINB3  PINB2  PINB1  PINB0
    0x04   DDRB     DDB7   DDB6   DDB5   DDB4   DDB3   DDB2   DDB1   DDB0
    0x05   PORTB    PORTB7 PORTB6 PORTB5 PORTB4 PORTB3 PORTB2 PORTB1 PORTB0
    0x06   PINC     x      PINC6  PINC5  PINC4  PINC3  PINC2  PINC1  PINC0
    0x07   DDRC     x      DDC6   DDC5   DDC4   DDC3   DDC2   DDC1   DDC0
    0x08   PORTC    x      PORTC6 PORTC5 PORTC4 PORTC3 PORTC2 PORTC1 PORTC0
    0x09   PIND     PIND7  PIND6  PIND5  PIND4  PIND3  PIND2  PIND1  PIND0
    0x0A   DDRD     DDD7   DDD6   DDD5   DDD4   DDD3   DDD2   DDD1   DDD0
    0x0B   PORTD    PORTD7 PORTD6 PORTD5 PORTD4 PORTD3 PORTD2 PORTD1 PORTD0 */

    // asm ( "sbi %0, %1 \n" : : "I" (_SFR_IO_ADDR(PORTB)), "I" (PORTB5));

byte can[12];

void wait_1us(void)
{
   __asm__ __volatile__ ("nop\n\t");
   __asm__ __volatile__ ("nop\n\t");
   __asm__ __volatile__ ("nop\n\t");
   __asm__ __volatile__ ("nop\n\t");
   __asm__ __volatile__ ("nop\n\t");
   __asm__ __volatile__ ("nop\n\t");
   __asm__ __volatile__ ("nop\n\t");
   __asm__ __volatile__ ("nop\n\t");
   __asm__ __volatile__ ("nop\n\t");
   __asm__ __volatile__ ("nop\n\t");
   __asm__ __volatile__ ("nop\n\t");
   __asm__ __volatile__ ("nop\n\t");
}

void maj_can(void)
{
#if use_centraleB == 1
    byte savePORTB; //D13-D12-D11-D10-D9-D8     D12=AIGS3 D11=AIGS2 D10=AIGS1 D9=AIGS0 D8=AIGDR
    byte savePORTD; //D7-D0                     D7=AIGGO

    //desactivation des min (car la lecture can joue avec les memes entrees)
    rd_min_it_enable=0;       
    //delayMicroseconds(80);
    //pas besoin d'attendre car on fait cela forcement en dehors de l'IT 
    //min est coupe pendant 1ms ce qui n'est pas bien grave car maj min dure 900us -> 500Hz suffisant

    // desactivation des aiguillages (car les commandes sont en // des entrees)
    savePORTB = PORTB;
    savePORTD = PORTD;
    __asm__ __volatile__ ("cbi 11,7\n\t"); //equivalent a digitalWrite(PIN_AIGGO , LOW); mais en bcp plus rapide
    PORTB |= 0x1f;
    //aig est coupe pendant 1ms ce qui n'est pas bien grave (1ms/(125ms/2)=1.6%)
#endif

    delayMicroseconds(50);  //attente que tout se calme pour faire une bonne lecture.UU: essayer avec une valeur plus petite
  
    digitalWrite(2,HIGH);   //INSA
    digitalWrite(3,HIGH);   //INSB

    digitalWrite(2,LOW);   //INSA
    wait_1us();
    #if use_DCCB == 0
    can[0]= analogRead(A1) / 4;   //si pas DCC#
    #else
    can[0]=255; //en l'air
    #endif
    can[1]= analogRead(A2) / 4;
    can[2]= analogRead(A3) / 4;
    can[3]= analogRead(A4) / 4;
    can[4]= analogRead(A5) / 4;
    digitalWrite(2,HIGH);   //INSA

    digitalWrite(3,LOW);   //INSB
    wait_1us();
    #if use_DCCB == 0
    can[5]= analogRead(A1) / 4;   //si pas DCC#
    #else
    can[5]=255; //en l'air
    #endif    
    can[6]= analogRead(A2) / 4;
    can[7]= analogRead(A3) / 4;
    can[8]= analogRead(A4) / 4;
    can[9]= analogRead(A5) / 4;
    digitalWrite(3,HIGH);   //INSB

#if use_centraleB == 1
    //re-activation des aig
    PORTB = savePORTB;
    if(savePORTD & 0x80) { __asm__ __volatile__ ("sbi 11,7\n\t"); }
    else                 { __asm__ __volatile__ ("cbi 11,7\n\t"); }   
    //re-activation des min
    rd_min_it_enable=1;   
#endif

    can[10]= analogRead(A6) / 4;    //ANA
    can[11]= analogRead(A7) / 4;    //ANB
}

void debug_can(void)
{
  byte i;
  for(i=0;i<12;i++)
  {
    Serial.print("can"); Serial.print(i); Serial.print("="); Serial.println(can[i]);   
  }
}



//------------------------------------------------------------------------------
// MOUSE
//------------------------------------------------------------------------------

//avec temps de boucle 125ms
//#define BP_COURT 4
//#define BP_MOY  32
//#define BP_IDLE  7
//avec temps de boucle 62ms
#define BP_COURT 6
#define BP_MOY  64
#define BP_IDLE 13

#define M_DISC  0
#define M_0     1
#define M_BP    2
#define M_PLUS  3
#define M_MOINS 4
#define M_ERROR 5

//2.2kOhms, matrice (ok aussi avec masse)
#define M_IS_DISC  (an0>(200   )                )
#define M_IS_0     (an0>(129-10) && an0<(142+10))
#define M_IS_MOINS (an0>(100-10) && an0<(109+10))
#define M_IS_PLUS  (an0>( 70-10) && an0<( 76+10))
#define M_IS_BP    (                an0<( 39+10))

class Mouse
{
    public:
        Mouse(void);          // constructeur
        void maj(byte can_value);  // a appeller toute les 125ms avec la valeur du CAN
        void bp_update(byte bp);   // fonction interne qui gere les fonctions du BP
    
        byte adr = 0;              // adresse de la loco DCC (adr 0 = inactive)
    
    private:
        void __change_adr(byte _adr);
        void __change_fct(byte _fct);
        void __change_sens(void);
        void __inc_vit(void);
        void __dec_vit(void);
        void __au(void);
        void __stop_au(void);

        byte new_m = M_DISC;       // nouvel etat d'appuie des boutons
        byte old_m = M_DISC;       // ancien etat d'appuie des boutons
        byte same_m_cpt =0;        // duree de cet etat stable

        byte bp_old    = 0;        // ancien etat du bp
        byte bp_idle   = 0;        // duree idle
        byte bp_press  = 0;        // duree presse
        byte bp_moy    = 0;        // nb de pulse moyennes
        byte bp_court  = 0;        // nb de pulse courtes
        byte bp_long   = 0;        // nb de pulse longues        
};

Mouse::Mouse(void)
{
  /*
    enable = 0;
    adr = 0;   
    
    new_m = M_DISC;
    old_m = M_DISC;
    same_m_cpt = 0;

    bp_old    = 0;
    bp_idle   = 0;
    bp_press  = 0;
    bp_moy    = 0;
    bp_court  = 0;
    bp_long   = 0;  */
}

void Mouse::__change_adr(byte _adr)
{
   #if use_DBG_mouse == 1
       Serial.print("__adr "); Serial.println(_adr);
   #endif       
   adr = _adr;
}

void Mouse::__change_fct(byte _fct)
{  
   byte fct;

   #if use_DBG_mouse == 1
       Serial.println("__fct");
   #endif       
   
   fct  = dcc.get_fct43210(adr);
   fct^=(1<<_fct);
   dcc.update_loc_fct(adr, fct);
}

void Mouse::__change_sens(void)
{
   byte sens;

   #if use_DBG_mouse == 1
       Serial.println("__sens");
   #endif
   
   sens = dcc.get_sens(adr);
   sens^=1;
   dcc.update_loc_sens(adr, sens);
}

void Mouse::__inc_vit(void)
{
    byte vit;
    
    #if use_DBG_mouse == 1
        Serial.println("__inc vit"); 
    #endif
    
    vit = dcc.get_vit(adr);
    if(vit<28) vit++;
    dcc.update_loc_vit(adr, vit);       
    #if use_DBG_mouse == 1
        Serial.print("vit="); Serial.println(vit);   
    #endif
}

void Mouse::__dec_vit(void)
{
    byte vit;

    #if use_DBG_mouse == 1
       Serial.println("__dec vit");   
    #endif

    vit  = dcc.get_vit(adr);
    if(vit>0) vit--;
    dcc.update_loc_vit(adr, vit);   
    #if use_DBG_mouse == 1
        Serial.print("vit="); Serial.println(vit);   
    #endif
}

void Mouse::__au(void)
{
    //if(au==1) return;
    #if use_DBG_mouse == 1
        Serial.println("__au");
    #endif
    dcc_au=1;
}

void Mouse::__stop_au(void)
{
    //if(au==0) return;
    #if use_DBG_mouse == 1
        Serial.println("__stop_au");
    #endif
    dcc_au=0;
}

// fonction de mise a jour des ordres des boutons
void Mouse::bp_update(byte bp)
{
    // mise a jour de la duree des etats
    if(bp==0) if(bp_idle <20) bp_idle++;
    if(bp==1) if(bp_press<100) bp_press++;
    
    // comptabilisation des impulsions
    if(bp_old==1 && bp==0)
    {
        if     (bp_press<=BP_COURT) bp_court++; //400ms max  //typ 62-372ms  
        else if(bp_press<=BP_MOY  ) bp_moy++;   //4s max     //typ 1-2s
        else                        bp_long++;  //4s min     //typ 10s     

        // cas particulier de l'AU fait maintenant en priorite sans attendre l'etat bas 1s
        if(bp_long==0 && bp_moy==0 && bp_court==2) __au();
    }
    ////Serial.print("bp="    ); Serial.print(bp);
    ////Serial.print(" idle=" ); Serial.print(bp_idle);
    ////Serial.print(" press="); Serial.print(bp_press);
    ////Serial.print(" court="); Serial.print(bp_court);
    ////Serial.print(" moy="  ); Serial.print(bp_moy);
    ////Serial.print(" long=" ); Serial.println(bp_long);
       
    // prise en compte des ordres apres un repo suffisant
    if(bp_idle==BP_IDLE)  // idle pendant 800ms
    {
        if(bp_long==0 && bp_moy==0)
        {
            if(bp_court==1) __change_sens();
          //if(bp_court==2) __au();  //(fait maintenant en priorite sans attendre l'etat bas)
            if(bp_court==3) __stop_au();
        }
        else if(bp_long==1)
        {
            __change_adr(10*bp_moy+bp_court);
        }
        else if(bp_moy==1)
        {
            __change_fct(bp_court);
        }
        bp_long=bp_moy=bp_court=0;
    }
    
    // remise a zero de la duree des etats
    if(bp==0) bp_press=0;
    if(bp==1) bp_idle=0;
    bp_old=bp;

    //cptm++;
}

void Mouse::maj(byte can_value)
{
  byte an0;
 
  an0 = can_value;
  //Serial.print("an_0="); Serial.println(an0);

  old_m = new_m;

  if(     M_IS_DISC ) new_m = M_DISC;
  else if(M_IS_0    ) new_m = M_0;
  else if(M_IS_MOINS) new_m = M_MOINS;
  else if(M_IS_PLUS ) new_m = M_PLUS;
  else if(M_IS_BP   ) new_m = M_BP;
  else                new_m = M_ERROR;

  if(new_m == M_BP) bp_update(1); else bp_update(0);

  if(new_m!=old_m)
  {
    if(same_m_cpt==1)
    {
      if(old_m==M_PLUS ) __inc_vit();
      if(old_m==M_MOINS) __dec_vit();
    }
    
    same_m_cpt=1;
    #if use_DBG_mouse == 1
        Serial.print("an0="); Serial.print(an0); Serial.print(" ");      

        if(     new_m==M_DISC ) Serial.print("disconnected");
        else if(new_m==M_BP   ) Serial.print("bp");
        else if(new_m==M_0    ) Serial.print("rien");
        else if(new_m==M_PLUS ) Serial.print("plus ");
        else if(new_m==M_MOINS) Serial.print("moins");

        //if(old_m==M_0 && new_m==M_PLUS ) { compt2++; Serial.print("cpt="); Serial.print(compt2);}
        //if(old_m==M_0 && new_m==M_MOINS) { compt2--; Serial.print("cpt="); Serial.print(compt2);}

        Serial.println("");  
    #endif        
  }
  else
  {
    if(same_m_cpt<100) same_m_cpt++;
  }

  if(same_m_cpt>1)
  {
    if(old_m==M_PLUS ) __inc_vit();
    if(old_m==M_MOINS) __dec_vit();
  }
}

#define MOUSE_NB 10
Mouse mouse[MOUSE_NB];

void mouse_init(void)
{
    //config and enable used mouses
    mouse[0].adr = MOUSE_0_ADR;
    mouse[1].adr = MOUSE_1_ADR;
    mouse[2].adr = MOUSE_2_ADR;
    mouse[3].adr = MOUSE_3_ADR;
    mouse[4].adr = MOUSE_4_ADR;
    mouse[5].adr = MOUSE_5_ADR;
    mouse[6].adr = MOUSE_6_ADR;
    mouse[7].adr = MOUSE_7_ADR;
    mouse[8].adr = MOUSE_8_ADR;
    mouse[9].adr = MOUSE_9_ADR;
}

void mouse_maj(void)
{
     byte i;
     for(i=0;i<MOUSE_NB;i++)
     {
         mouse[i].maj(can[i]);
     }
}



//------------------------------------------------------------------------------
// Neopixel
//------------------------------------------------------------------------------

#define SERIAL_RX_DURING_NEO_BUFF_SIZE 32
byte serial_rx_during_neo_buff[SERIAL_RX_DURING_NEO_BUFF_SIZE];
byte serial_rx_during_neo_wr = 0;
byte serial_rx_during_neo_rd = 0;

void serial_neo_in()
{
  // initialise la reception dans le buffer hors IT
  serial_rx_during_neo_wr = 0;
  serial_rx_during_neo_rd = 0;
}

void serial_neo_update_buff(void)  //UU: essayer en inline
{
    unsigned char c;

    if(serial_rx_during_neo_wr == SERIAL_RX_DURING_NEO_BUFF_SIZE) return; // ne devrait jamais arrive car 32*100us=3.2ms
        
    #if defined(UDR0)
        if (bit_is_set(UCSR0A, RXC0)==0) return;
        c = UDR0;
    #elif defined(UDR)
        if (bit_is_set(UCSRA, RXC)==0) return;
        c = UDR;
    #endif

    serial_rx_during_neo_buff[serial_rx_during_neo_wr]=c;
    serial_rx_during_neo_wr++;
}

void serial_neo_out()
{
    serial_maj();
    serial_rx_during_neo_wr = 0;
    serial_rx_during_neo_rd = 0;
}

/*
neopixel
official ns
H0  200-500  L0  650-950
H1  550-850  L1  450-750
RESET 50000 min
test
H0 200-500
H1 550-oo   L 450-5000
RESET 6000 min
G(8bits7-->0)R(8bits)B(8bits)  
*/

#define NEO_NB 60
#define NEO_R 0
#define NEO_V 1
#define NEO_B 2
unsigned char neo_rvb[NEO_NB][3];

void neo_reset(void)  //6 us mini  -> 10us
{
    unsigned char i;
    
    PORTB &= 0xfe;
    __asm__ __volatile__ ("cbi 5,5\n\t");  //digital 13 = PORTB bit5
    //for(i=0;i<40;i++)  // par bcl: 3cycle+nb nop   1nop -> 4*62.5ns = 250ns   01us=40bcl
    for(i=0;i<100;i++)  // par bcl: 3cycle+nb nop   1nop -> 4*62.5ns = 250ns   01us=40bcl
    {
      //__asm__ __volatile__("nop\n\t"); //62.5ns
      NOP;
    }
}

//#pragma GCC push_options
//#pragma GCC optimize ("O0")
//#pragma GCC pop_options      
//PORTB |= 1;  then NOP; marche pas car l'optim metait des tests entre

//  mesures
// 1court: 0.375us
// 1long : 0.750us
// bas   : 0.750-937us   1625us entre 2 bytes  3125us entre 2 24bits
void neo_tx_byte(unsigned char val) //UU: check the code of this function in assembly (mainly after opimization !!!!)
{
    unsigned char i;
    
    for(i=0;i<8;i++)
    {
      if(val&0x80)   // TX_H_1   550-oo ns --> 600ns   10nop+1port=10*62.5=625ns  //uu:try to reduce
      {
            asm volatile(
            "sbi 5, 5\n\t"      //mise a 1 digital 13 PB5
            "nop\n\t"           //9x NOP
            "nop\n\t"
            "nop\n\t"
            "nop\n\t"
            "nop\n\t"
            "nop\n\t"
            "nop\n\t"
            "nop\n\t"
            "nop\n\t"
            "cbi 0x05, 5\n\t"); //mise a 0 digital 13 PB5
      } 
      else   // TX_H_0  200-500ns --> 400ns 4nop+port=5*62.5=310ns
      {
            asm volatile(
            "sbi 0x05, 5\n\t"   //mise a 1 digital 13 PB5
            "nop\n\t"           //4x NOP
            "nop\n\t"
            "nop\n\t"
            "nop\n\t"
            "cbi 0x05, 5\n\t"); //mise a 0 digital 13 PB5
      }
      // TX_L  450->5000ns --> 600ns      sans les nop:500ns, 4nop: +248ns -> 1us  //uu: try tu reduce      
     asm volatile(
       "nop\n\t"
       "nop\n\t"
       "nop\n\t"
       "nop\n\t"); 
      val = val << 1;
      //serial_neo_update_buff();
    }  
}

void neo_display()
{
    unsigned char i;

    dcc.sstop();
    while(1)
    {
        serial_maj();    // a faire avec les ITs activees car serial_maj peut prendre du temps et on peut louper des rx si on n'est plus sous it
        noInterrupts();  //cli();
        if(Serial.available()) interrupts();
        else                   break;
    }
    serial_neo_in();
  
    neo_reset();
    for(i=0;i<NEO_NB;i++)
    {
        neo_tx_byte(neo_rvb[i][NEO_V]);    
        neo_tx_byte(neo_rvb[i][NEO_R]);    
        neo_tx_byte(neo_rvb[i][NEO_B]);    
        serial_neo_update_buff(); // on est pendant le TX_L. suffisant de l'appeller tous les 24bits car <100us (duree reception a 115200bps). uu: mesurer la duree avec le LA
    }
    neo_reset();
    
    interrupts();  //sei();
    serial_neo_out();
    dcc.restart();    
}

void neo_set_rvb_pixel(unsigned char pixel, unsigned char r, unsigned char v, unsigned char b)
{
    neo_rvb[pixel][NEO_R] = r;
    neo_rvb[pixel][NEO_V] = v;
    neo_rvb[pixel][NEO_B] = b;
}

void neo_init(void)
{
    #if use_CLI == 1
        return;
    #endif
    
    byte i;
    for(i=0; i<NEO_NB;i++)
    {
        neo_set_rvb_pixel(i, 0, 0, 0);  //on demarre a 0 pour ne pas trop charger une faible alimentation
        //neo_set_rvb_pixel(i, 0, 0, 10);  //on demarre a 0 pour ne pas trop charger une faible alimentation
        //if(     i==10) neo_set_rvb_pixel(i, 10, 0, 0);  
        //else if(i==20) neo_set_rvb_pixel(i, 0, 10, 0);  
        //else if(i==30) neo_set_rvb_pixel(i, 0, 0, 10);  
    }
    neo_display();  
    neo_display();
}

void neo_maj(void)
{
    #if use_CLI == 1
        return;
    #endif

    //pour tester avec les leds
    //byte i;
    //for(i=0; i<NEO_NB;i++)
    //{
    //   if(io_led[i/8] & (1<<(i&7))) neo_set_rvb_pixel(i,  0, 10, 0);
    //   else                         neo_set_rvb_pixel(i, 10,  0, 0);
    //}
          
    neo_display();
}



//------------------------------------------------------------------------------
// E/S (IN,OUT,LED,PWM,CLI)
//------------------------------------------------------------------------------

#define PIN_CLI   13   //ou NEO
#define PIN_DIN   12
#define PIN_RST   11
#define PIN_PWM51 10
#define PIN_PWM50 9
#define PIN_LDIN  8
#define PIN_LDOUT 7
#define PIN_PWM49 6    //ou SCK
#define PIN_PWM48 5    //ou SDA
#define PIN_LDLED 4
#define PIN_DOUT  3
#define PIN_CLK   2

#define PIN_AIGS3 12
#define PIN_AIGS2 11
#define PIN_AIGS1 10
#define PIN_AIGS0 9
#define PIN_AIGDR 8
#define PIN_AIGGO 7


byte io_out[8]  = { 0, 0, 0, 0 ,0, 0, 0, 0 };  // 64 sorties
//byte io_in[32];   // 256 entrees #define IO_IN 256   definit plus haut maintenat car utilise sous it pour les min)
byte io_inmem[32];  // memorisation des entrees
byte io_led[32]     = { 0, 0, 0, 0 ,0, 0, 0, 0,    0, 0, 0, 0 ,0, 0, 0, 0,    0, 0, 0, 0 ,0, 0, 0, 0,    0, 0, 0, 0 ,0, 0, 0, 0 };  // possibilite d'initialiser les valeurs
byte io_cli[32]     = { 0, 0, 0, 0 ,0, 0, 0, 0,    0, 0, 0, 0 ,0, 0, 0, 0,    0, 0, 0, 0 ,0, 0, 0, 0,    0, 0, 0, 0 ,0, 0, 0, 0 };  // ex led clignotante
byte io_pha[32]     = { 0, 0, 0, 0 ,0, 0, 0, 0,    0, 0, 0, 0 ,0, 0, 0, 0,    0, 0, 0, 0 ,0, 0, 0, 0,    0, 0, 0, 0 ,0, 0, 0, 0 };
byte io_pwm[48+4]   = { 0, 0, 0, 0 ,0, 0, 0, 0,    0, 0, 0, 0 ,0, 0, 0, 0,    0, 0, 0, 0 ,0, 0, 0, 0,    0, 0, 0, 0 ,0, 0, 0, 0,    0, 0, 0, 0 ,0, 0, 0, 0,     0, 0, 0, 0 ,0, 0, 0, 0,    0, 64, 128, 255};
byte io_srv[48];
//byte io_srv_cmd[48] = { 150, 150, 150, 150, 150, 150, 150, 150,    150, 150, 150, 150, 150, 150, 150, 150,    150, 150, 150, 150, 150, 150, 150, 150,    150, 150, 150, 150, 150, 150, 150, 150,    150, 150, 150, 150, 150, 150, 150, 150,   150, 150, 150, 150, 150, 150, 150, 150 };  //*10us 150=1500us=1.5ms=neutre     //declare plus haut maintenant
//byte io_srv_vit[48] = {  50,  50,  50,  50,  50,  50,  50,  50,     50,  50,  50,  50,  50,  50,  50,  50,    50,  50,  50,  50,  50,  50,  50,  50,     50,  50,  50,  50,  50,  50,  50,  50,     50,  50,  50,  50,  50,  50,  50,  50,    50,  50,  50,  50,  50,  50,  50,  50  };  //1 =env 1deg/sec                   //declare plus haut maintenant
// les aiguillages ont leur propre structure
byte aig_4094_0 = 0, aig_4094_1 = 0, aig_4094_2 = 0, aig_4094_3 = 0;  //0 est le plus proche, 3 le plus lointain 0=ULN/1=L293D 2=ULN/3=L293D
byte aig_GD3210 = 0;


// utilisation de 25us sur S88 soit une periode de 50us et une frequence de 20kHz
// Cette basse frequence permet de fonctionner avec des uc qui emulent lentement le S88 au lieu des 4014/2021  
// Duree totale theorique:12.8ms, mesure:20ms
unsigned char in_shift8(void)
{
    unsigned char i, dat;
    
    for(i=0; i<8; i++)
    {
        dat = dat >> 1;
        if(digitalRead(PIN_DIN) == HIGH) dat |= 0x80;
        digitalWrite(PIN_CLK, HIGH); delayMicroseconds(25); digitalWrite(PIN_CLK, LOW); delayMicroseconds(25);
    }
    return dat;    
}

void in_maj_a(void)
{
    unsigned char i;

    digitalWrite(PIN_CLK , LOW ); delayMicroseconds(25);  //mise a 0 car utilisee par d'autres fonctions qui peuvent l'avoir mise a 1
    digitalWrite(PIN_LDIN, HIGH); delayMicroseconds(25);
    digitalWrite(PIN_CLK , HIGH); delayMicroseconds(25);
    digitalWrite(PIN_CLK , LOW ); delayMicroseconds(25);
    digitalWrite(PIN_LDIN, LOW ); delayMicroseconds(25);
    digitalWrite(PIN_RST , HIGH); delayMicroseconds(25);
    digitalWrite(PIN_RST , LOW ); delayMicroseconds(25);
    
    for(i = 0; i < (256 / 8); i++)
    {
        io_in[i] = in_shift8();
        io_inmem[i] |= io_in[i];
    }      
}

void in_maj_b(void)
{
    unsigned char i;
  
    for(i = 0; i < (256 / 8); i++)
    {
        io_inmem[i] |= io_in[i];
        io_in[i] = 0;                //io_in[i] est mis a jour sous it
    }      
  
}


void in_init(void)
{
    unsigned char i;
      
    #if use_centraleA == 1
    in_maj_a();  //premier passage a vide vider les memorisation des S88
    #endif

    for(i=0;i<(256/8);i++)
    {
        io_in[i] = io_inmem[i] = 0;
    }      
}

//clk pin change us  (1us->T=2us=512kHz )
void led_out_shift8(unsigned char dat)
{
     unsigned char i;
     
     for(i=0;i<8;i++)
     {
         //if(dat&0x80) digitalWrite(PIN_DOUT , HIGH); else digitalWrite(PIN_DOUT , LOW);
         //delayMicroseconds(1);
         //digitalWrite(PIN_CLK, HIGH); delayMicroseconds(1); digitalWrite(PIN_CLK, LOW);
         //delayMicroseconds(1);

         if(dat&0x80)
             __asm__ __volatile__ ("sbi 11,3\n\t"); // PIN_DOUT=HIGH equivalent a digitalWrite(PIN_DOUT, HIGH); mais en bcp plus rapide
         else
             __asm__ __volatile__ ("cbi 11,3\n\t"); // PIN_DOUT=LOW
         delayMicroseconds(4);
         __asm__ __volatile__ ("sbi 11,2\n\t"); // PIN_CLK=HIGH
         delayMicroseconds(4);  //periode=8us = 125KHz (ok sur longue distances)
         __asm__ __volatile__ ("cbi 11,2\n\t"); // PIN_CLK=LOW
         //delayMicroseconds(1);

         dat=dat<<1;
     }  
}

//du plus proche au plus loin de la centrale
//unsigned char sout_config[] = { SOUT_OUT0_7, SOUT_OUT8_15, SOUT_AIG0_47, SOUT_OUT16_23, SOUT_AIG48_95, SOUT_OUT24_31, SOUT_OUT32_39, SOUT_OUT40_47, SOUT_OUT48_55, SOUT_OUT56_63, SOUT_END };
void out_maj(void)
{
     byte i, module;

     i=0;
     while(1)
     {
         if(sout_config[i] == SOUT_END) break; 
         i++;
     }

     while(i)
     {
         i--;
         module = sout_config[i];
         if(module >= 0 && module <= 7) led_out_shift8(io_out[module]);
         if(module == SOUT_AIG0_47 ) { led_out_shift8(aig_4094_1); led_out_shift8(aig_4094_0); }   //0=uln 1=l293d  
         if(module == SOUT_AIG48_95) { led_out_shift8(aig_4094_3); led_out_shift8(aig_4094_2); }   //2=uln 3=l293d
     }
     
     digitalWrite(PIN_LDOUT, LOW); delayMicroseconds(4); digitalWrite(PIN_LDOUT, HIGH); delayMicroseconds(4); digitalWrite(PIN_LDOUT, LOW); delayMicroseconds(4);    
}

void out_init(void)
{
    //unsigned char i;
    //for(i=0;i<8;i++) io_out[i] = 0;
    //pas d'initialisation, initialisation suivant le tableau io_out
}


void led_maj_4max(unsigned char h0, unsigned char l0, unsigned char h1, unsigned char l1, unsigned char h2, unsigned char l2, unsigned char h3, unsigned char l3)
{
     digitalWrite(PIN_LDLED, HIGH); delayMicroseconds(10); digitalWrite(PIN_LDLED, LOW); delayMicroseconds(10);
     led_out_shift8(h3);
     led_out_shift8(l3); 
     led_out_shift8(h2);
     led_out_shift8(l2); 
     led_out_shift8(h1);
     led_out_shift8(l1); 
     led_out_shift8(h0);
     led_out_shift8(l0);
     digitalWrite(PIN_LDLED, HIGH); delayMicroseconds(10);
}

byte compute_led_on_cli_phase(byte on, byte cli, byte phase)
{
    byte led;

    if(cpt_125ms & 8) led = 0xff;  else led = 0;   //clignotement 1Hz
    led ^= phase;                           //changement de phase
    led |= ~cli;                            //allumer si pas clignotant
    led &= on;                              //eteindre si pas on

    return led;
}

void led_maj(void)
{
    unsigned char i, led_max0, led_max1, led_max2, led_max3; 
  
    for(i=0;i<8;i++)
    {
        led_max0 = compute_led_on_cli_phase(io_led[i   ], io_cli[i   ], io_pha[i   ]);
        led_max1 = compute_led_on_cli_phase(io_led[i+8 ], io_cli[i+8 ], io_pha[i+8 ]);
        led_max2 = compute_led_on_cli_phase(io_led[i+16], io_cli[i+16], io_pha[i+16]);
        led_max3 = compute_led_on_cli_phase(io_led[i+24], io_cli[i+24], io_pha[i+24]);

        #if use_centraleB == 1
        rd_min_it_enable=0;       //desactivation des min car la clk&dat led activent les colonnes
        #endif                    //min est coupe pendant 1ms ce qui n'est pas bien grae car maj min dure 900us -> 500Hz suffisant    //uu: verifier cela car doit prendre un peu plus
        
        led_maj_4max(i+1,led_max0,i+1,led_max1,i+1,led_max2,i+1,led_max3);
      
        digitalWrite(PIN_CLK , HIGH);  //re-activation des min (en ayant pris soin de desactiver les colonnes)
        digitalWrite(PIN_DOUT, HIGH);
        delayMicroseconds(2);
        #if use_centraleB == 1
        rd_min_it_enable=1;   
        #endif  
        delayMicroseconds(1000); //leave time to update min 5col * 3x * 58us = 870us
  }

}

void led_init(void)
{
    //pas d'initialisation, initialisation suivant le tableau io_led
    //unsigned char i;
    //for(i=0;i<32;i++) io_led[i] = 0;
                                                   // R0    : bypass
                                                   // R1-8  : data
    led_maj_4max(9  ,  0,  9,  0,  9,  0,  9,  0); // R9    : decode mode off (1ere fois pas sure que ca marche) 
    led_maj_4max(9  ,  0,  9,  0,  9,  0,  9,  0); // R9    : decode mode off
  //led_maj_4max(0xa,0xf,0xa,0xf,0xa,0xf,0xa,0xf); // R10   : intensite max
    led_maj_4max(0xa,0x4,0xa,0x4,0xa,0x4,0xa,0x4); // R10   : intensite 4/15
    led_maj_4max(0xb,  7,0xb,  7,0xb,  7,0xb,  7); // R11   : 8 digit    
    led_maj_4max(0xc,  1,0xc,  1,0xc,  1,0xc,  1); // R12   :shutdown mode off
                                                   // R13-14: NA
   led_maj_4max(0xf,  0,0xf,  0,0xf,  0,0xf,  0); // R15   :test mode off
   //led_maj_4max(0xf,  1,0xf,  1,0xf,  1,0xf,  1);

    led_maj();
}

void cli_init(void)  //aucune init
{ 
#if use_CLI == 1
#endif           
}

void cli_maj(void)
{
#if use_CLI == 1
    if(dcc_au==0) if(cpt_125ms&4) digitalWrite(PIN_CLI, LOW); else digitalWrite(PIN_CLI, HIGH);    // 1Hz
    if(dcc_au==1) if((cpt_125ms&3)==0) digitalWrite(PIN_CLI, LOW); else digitalWrite(PIN_CLI, HIGH);    // 2Hz
#endif           
}

// D10~  T1B   OUT5/SRV5/PWM3/PAP3
// D9~   T1A   OUT4/SRV4/PWM2/PAP2
// D6~   T0A   OUT1/SRV1/PWM1/PAP1
// D5~   T0B   OUT0/SRV0/PWM0/PAP0
void pwm_maj(void)
{
#if use_i2c == 0    
    analogWrite(PIN_PWM48, io_pwm[48]);  
    analogWrite(PIN_PWM49, io_pwm[49]);
#endif    
#if use_centraleA == 1         
    analogWrite(PIN_PWM50, io_pwm[50]);  
    analogWrite(PIN_PWM51, io_pwm[51]);
#endif
}

void pwm_init(void)
{
    pwm_maj();
}



//------------------------------------------------------------------------------
// I2C
//------------------------------------------------------------------------------

void init_pca9685(byte i2c_adr);

// implementation maison sur des pattes normales car on n'utilise pas le module i2c

//    0x09   PIND     PIND7  PIND6  PIND5  PIND4  PIND3  PIND2  PIND1  PIND0
//    0x0A   DDRD     DDD7   DDD6   DDD5   DDD4   DDD3   DDD2   DDD1   DDD0
//    0x0B   PORTD    PORTD7 PORTD6 PORTD5 PORTD4 PORTD3 PORTD2 PORTD1 PORTD0 */

#define PIN_SCK   5   // PORTD.5
#define PIN_SDA   6   // PORTD.6

#if 1
#define SDA_1 __asm__ __volatile__ ("cbi 10,6\n\t"); //SDA=entree   -> 1 sur pin
#define SDA_0 __asm__ __volatile__ ("sbi 10,6\n\t"); //SDA=sortie   -> 0 sur pin
#define SCK_1 __asm__ __volatile__ ("cbi 10,5\n\t"); //SCK=entree   -> 1 sur pin
#define SCK_0 __asm__ __volatile__ ("sbi 10,5\n\t"); //SCK=sortie   -> 0 sur pin

void i2c_init(void) //on emule un collecteur ouvert en mettant les sorties a 0 et en jouant sur la direction.
{
    __asm__ __volatile__ ("cbi 11,5\n\t"); //PORTD.5=0  SCK=0 (a 0 pour simuler un pull-down lorsqu'on met en sortie
    __asm__ __volatile__ ("cbi 11,6\n\t"); //PORTD.6=0  SDA=0 (a 0 pour simuler un pull-down lorsqu'on met en sortie
    SCK_1;
    SDA_1;

    init_pca9685(0);
    init_pca9685(1);
    init_pca9685(2);
}
#endif

#if 0   //uu: sorties directes sans la RP (pour tests)
#define SDA_1 __asm__ __volatile__ ("sbi 11,6\n\t"); //SDA -> 1 sur pin
#define SDA_0 __asm__ __volatile__ ("cbi 11,6\n\t"); //SDA -> 0 sur pin
#define SCK_1 __asm__ __volatile__ ("sbi 11,5\n\t"); //SCK -> 1 sur pin
#define SCK_0 __asm__ __volatile__ ("cbi 11,5\n\t"); //SCK -> 0 sur pin

void i2c_init(void) //on emule un collecteur ouvert en mettant les sorties a 0 et en jouant sur la direction.
{
    __asm__ __volatile__ ("sbi 10,5\n\t"); //PORTD.5 SCK en sortie
    __asm__ __volatile__ ("sbi 10,6\n\t"); //PORTD.6 SCK en sortie
    SCK_1;
    SDA_1;

    init_pca9685(0);
    init_pca9685(1);
    init_pca9685(2);
}
#endif

void i2c_start(void)
{
    SDA_1; SCK_1; delayMicroseconds(5);  
    SDA_0; delayMicroseconds(5);
    SCK_0; delayMicroseconds(5);  
}

void i2c_stop(void)
{
    SDA_0; SCK_0; delayMicroseconds(5);  
    SCK_1; delayMicroseconds(5);  
    SDA_1; delayMicroseconds(5);  
}

void i2c_wr_8(byte data)
{
    byte i;

    for(i=0;i<8;i++)
    {
        if(data&0x80) { SDA_1; } else { SDA_0; } delayMicroseconds(4);  
        SCK_1; delayMicroseconds(4);  
        SCK_0; delayMicroseconds(1);  
        data = data << 1;        
    }
    SDA_1; delayMicroseconds(1);  
}

byte i2c_rd_ack(void)
{
    byte ack;

    delayMicroseconds(4);  //before 0
    SCK_1; delayMicroseconds(4);  
    if(PORTD & 0x40) ack=0; /*nack*/ else ack=1; /*ack*/
    SCK_0; delayMicroseconds(1);  
    return ack;
    //return 1;  //uu pr le debug, tj un circuit !
}

byte i2c_rd_8(void)
{
    byte i, data;

    data=0;
    for(i=0;i<8;i++)
    {
        delayMicroseconds(4);  //before 0
        SCK_1; delayMicroseconds(4);  
        if(PORTD&0x40) data|=1;  
        SCK_0; delayMicroseconds(1);  
        data = data << 1;        
    }
    return data;  
}

byte i2c_wr_ack(byte ack)   //1=ack, 0=nack
{
    if(ack) { SDA_0; } else { SDA_1; } delayMicroseconds(4);  
    SCK_1; delayMicroseconds(4);  
    SCK_0; delayMicroseconds(1);  
}

#define PCA9685_MODE1_REG    0x00
#define PCA9685_MODE2_REG    0x01
#define PCA9685_LED0_REG     0x06
#define PCA9685_PRESCALE_REG 0xfe

byte set_pca9685_reg(byte i2c_adr, byte adr, byte dat)
{
    i2c_start();
    i2c_wr_8(0x80+2*i2c_adr);  //A6=1,A5-A0=pin,R/W#
    if(i2c_rd_ack()==0)
    {
        i2c_stop();  
        return 0;
    }
    i2c_wr_8(adr);    
    if(i2c_rd_ack()==0)
    {
        i2c_stop();  
        return 0;
    }
    i2c_wr_8(dat);    
    if(i2c_rd_ack()==0)
    {
        i2c_stop();  
        return 0;
    }
    i2c_stop();  
    return 1;
}

byte set_pca9685_out(byte i2c_adr, byte out, int on, int off)
{
    byte on_h, on_l, off_h, off_l;
    
    on_h  = byte(on  >> 8); on_l  = byte(on  & 255);  //existe aussi lowByte highByte
    off_h = byte(off >> 8); off_l = byte(off & 255); 

    i2c_start();  // A6=1,A5-A0=pin,R/W#
    i2c_wr_8(0x80+2*i2c_adr);          i2c_rd_ack();
    i2c_wr_8(PCA9685_LED0_REG+4*out);  i2c_rd_ack();
    i2c_wr_8(on_l);                    i2c_rd_ack();
    i2c_wr_8(on_h);                    i2c_rd_ack();
    i2c_wr_8(off_l);                   i2c_rd_ack();
    i2c_wr_8(off_h);                   i2c_rd_ack();
    i2c_stop();
}

byte set_pca9685_only_off_out(byte i2c_adr, byte out, int off)
{
    byte on_h, on_l, off_h, off_l;
    
    off_h = byte(off >> 8); off_l = byte(off & 255); 

    i2c_start();  // A6=1,A5-A0=pin,R/W#
    i2c_wr_8(0x80+2*i2c_adr);            i2c_rd_ack();
    i2c_wr_8(PCA9685_LED0_REG+4*out+2);  i2c_rd_ack();
    i2c_wr_8(off_l);                     i2c_rd_ack();
    i2c_wr_8(off_h);                     i2c_rd_ack();
    i2c_stop();
}

byte i2c_pca9685_online[3] = {0, 0, 0};
void init_pca9685(byte i2c_adr)
{
    int i;  

    // reset et config MODE1
    i2c_pca9685_online[i2c_adr] = set_pca9685_reg(i2c_adr,PCA9685_MODE1_REG,0xB0); //reset=1, extclk=0, autoincrement=1, sleep=1 (all leds are off after reset)
    if(i2c_pca9685_online[i2c_adr]==0) return;
    delay(1);

    // Frequence de decoupage
    // 50Hz pour les servos: 25.000.000/(4096*50Hz) - 1 = 122-1 = 121.
    // mesure:
    // 121 -> 18.7ms     -1.3ms     err -6.5%
    // 130 -> 19.92ms    -0.08ms    err  0.4%
    // 131 -> 20.07ms    +0.07ms    err  0.4%
    set_pca9685_reg(i2c_adr,PCA9685_PRESCALE_REG,130);

    // exit from sleep
    set_pca9685_reg(i2c_adr,PCA9685_MODE1_REG,0x20);    //reset=0, extclk=0, autoincrement=1, sleep=0
    delay(1); //wait exit from low power mode

    // config MODE2
    set_pca9685_reg(i2c_adr,PCA9685_MODE2_REG,0x04);     // invert=0 change=onSTOP out=totem off=led_0

    for(i=0;i<16;i++)
    {
        if(pca9685_cfg[16*i2c_adr + i]) set_pca9685_out(i2c_adr, i ,0 ,0x4000);             // PWM=0%
        else                            set_pca9685_out(i2c_adr, i ,0 ,2*int(io_srv[i]));   // 2*150 -> SRV=env1.5ms -> mesure=1.37ms
    }
    /*
    set_pca9685_out(0,0 ,4096,0); //out 0 always on
    set_pca9685_out(0,1 ,0,4096); //out 0 always off
    set_pca9685_out(0,8 ,0,2048); //out 50%
    set_pca9685_out(0,9 ,0,100);  //servo 0.5ms   102  -> ok LA 457us
    set_pca9685_out(0,10,0,200);  //servo 1.0ms   206
    set_pca9685_out(0,11,0,300);  //servo 1.5ms   308  -> ok LA 1.46ms
    set_pca9685_out(0,12,0,400);  //servo 2.0ms   410  
    set_pca9685_out(0,13,0,500);  //servo 2.5ms   512*4.882us=2.5ms    
    */
}

void maj_pca9685(byte i2c_adr)
{
    int i, v;
    unsigned int cfg;

    //set_pca9685_out(0,11,0,300);  //servo 1.5ms   308
    
    if(i2c_pca9685_online[i2c_adr]==0) return;

    for(i=0;i<16;i++)
    {
        if(pca9685_cfg[16*i2c_adr + i]) //PWM
        {
            v = int(io_pwm[16*i2c_adr+i]);
            if(v==0) set_pca9685_only_off_out(i2c_adr, i, 0x4000);  // ALL OFF
            else     set_pca9685_only_off_out(i2c_adr, i, v<<4);    // 0000#### ####0000
        }
        else //SRV
        {
            set_pca9685_only_off_out(i2c_adr, i, 2*int(io_srv[16*i2c_adr+i]));   //env srv=150->cmd=300->1.5ms  
        }
    }
}

void i2c_maj()
{
    maj_pca9685(0);
    maj_pca9685(1);
    maj_pca9685(2);
}

void maj_srv_slow(void)
{
    byte i, c, p, v, diff;
    
    for(i=0; i<48; i++)
    {
        c = io_srv_cmd[i]; 
        p = io_srv[i]; 
        if(c==p) continue;
        diff = abs(p - c);
        v = io_srv_vit[i]; 
        if(diff>v) diff=v;
        if(c<p) diff=-diff;
        io_srv[i] = p + diff;
    }
}

void init_srv_slow(void)
{
    byte i;

    for(i = 0; i < 48; i++) io_srv[i] = io_srv_cmd[i];
}



//------------------------------------------------------------------------------
// LOCOS ANALOGIQUES
//------------------------------------------------------------------------------
#define ALIM_ANALOG_MAX 5

class C_alim_analog   
{
    public:
        C_alim_analog(void) { adr = 0; }

        byte adr;
        byte pwm_vit;
        byte pwm_dir;
        byte pwm_cran1;
        byte pwm_cran28;
};

C_alim_analog alim_analog[ALIM_ANALOG_MAX];

void add_alim_analog(byte adr_, byte pwm_vit_, byte pwm_dir_, byte pwm_cran1_, byte pwm_cran28_)
{
    byte i;
    
    for(i=0; i<ALIM_ANALOG_MAX; i++)
    if(alim_analog[i].adr==0)
    {
        alim_analog[i].adr        = adr_;
        alim_analog[i].pwm_vit    = pwm_vit_;
        alim_analog[i].pwm_dir    = pwm_dir_;
        alim_analog[i].pwm_cran1  = pwm_cran1_;
        alim_analog[i].pwm_cran28 = pwm_cran28_;
        break;    
    }
}

void alim_analog_init(void)
{
    CONFIG_ALIM_ANALOG;
}

void maj_alim_analog(void)
{
    byte i, adr, sens, vit, pwm;
    
    for(i=0; i<ALIM_ANALOG_MAX; i++)
    if(alim_analog[i].adr!=0)
    {
        // recuperation du sens et de la vitesse de la locomotive numérique associee
        adr  = alim_analog[i].adr;
        sens = dcc.get_sens(adr);
        vit  = dcc.get_vit(adr);
        if(dcc_au) vit=0;

        // affectation du sens
        if(sens)
            io_pwm[alim_analog[i].pwm_dir] = 0;    // sortie a 0 pour avant
        else
            io_pwm[alim_analog[i].pwm_dir] = 255;  // sortie a 1 pour arriere

        // calcul de la valeur de la pwm et affectation
        if(vit==0) pwm = 0;                                                                     // pour vit == 0
        else       pwm = map(vit, 1, 28, alim_analog[i].pwm_cran1, alim_analog[i].pwm_cran28);  // pour vit == 1-28
        io_pwm[alim_analog[i].pwm_vit] = pwm;
    }  
}



//------------------------------------------------------------------------------
// AIGUILLAGES
//------------------------------------------------------------------------------

#define AIG_MAX 96

unsigned int aig_data[AIG_MAX];     //    unsigned int = 16bits sur UNO, NANO, MEGA
                                    //    T1.N6.N5.N4.N3.N2.N1.N0 inv.pulsems(3bits).T0.pos1.pos0.cmd
                                    //    inv            ->  inversion de la commande de l'aiguillage     
                                    //    pulsems 3 bits ->  0=aiguillage non utilise 1=125ms 2=250ms 3=500ms 4=1s 5=2s 6=5s 7=10s
                                    //    T1.T0          ->  Type: 00 = Sout   (centrale A)  aig0-95
                                    //                   ->        00 = Direct (centrale B)  aig0-15
                                    //                   ->        01 = SRV           (A+B)  aig0-47
                                    //                   ->        1x = reseve
                                    //    N6.N5.N4.N3.N2.N1.N0 -> Numero de l'aiguillage sur le module
                                    //    mettre les initialistion dans aig-init
                                    //    la duree de l'impulsion n'est pas valable pour les servos (utiliser io_srv_vit et io_srv_pos0/1)

//duree de preparation commune a tous les aiguillages (en multiple de 125ms) (sauf servos)
const unsigned char aig_prep = 0;

//duree de liberation commune a tous les aiguillages (en multiple de 125ms) (sauf servos)
const unsigned char aig_lib = 0;

unsigned char aig_no = 0;
#define AIG_NOP  0  // pas d'operation
#define AIG_PREP 1  // preparation
#define AIG_GO   2  // impulsion
#define AIG_LIB  3  // liberation
unsigned char aig_step = AIG_NOP;
unsigned char aig_timer;
byte aig_cmd;
byte aig_on = 0;
byte aig_wait_10s = 1; //attente 10s avant de mettre a jour les aiguillages (pour laisser le temps d'activer l'alim de puissance)
                       //une action serie d'activation ou desactivation des aiguillages, met cette variable a 0
byte aig_on_module = 0;
byte aig_move_srv = 0;


void aig_init(void)
{
     unsigned char i;
     
     // initialisation par defaut: desactivation des aiguillages.
     for(i = 0; i < AIG_MAX; i++) aig_data[i] = 0;
     
     // initialisation de l'utilisateur
     AIG_SPECIFIC_INIT;

     // pos0 et pos1 sont a 0 pour forcer l'initialisation
}

void aig_maj_s(void)
{
    if(io_srv_aig[aig_on_module] == 0) { aig_step = AIG_NOP; aig_move_srv = 0; aig_no++; return; }
                      
    if(aig_step == AIG_PREP)
    {
        if(aig_cmd) io_srv_cmd[aig_on_module] = io_srv_pos0[aig_on_module];
        else        io_srv_cmd[aig_on_module] = io_srv_pos1[aig_on_module];
        aig_step = AIG_GO;
    }
      
    if(aig_step == AIG_GO)
    {
        if(io_srv_cmd[aig_on_module] == io_srv[aig_on_module])
        {
            aig_step = AIG_LIB;
            aig_timer = 1;   //laisser un peu de temps pour etre sure que la mise a jour I2C est ok
        }
    }

    if(aig_step == AIG_LIB)
    {
        if(aig_timer) aig_timer--;
        else
        {
             aig_step = AIG_NOP;
             aig_move_srv = 0;
             aig_data[aig_no] &= 0xfff9;      //x,x,x,x,x,x,x,x, x,x,x,x,x,pos1=0,pos0=0,x
             if(aig_cmd == 0)
                  aig_data[aig_no] |= 0x0002;   // pos1=0 pos0=1
             else
                  aig_data[aig_no] |= 0x0004;   // pos1=1 pos0=0
            aig_no++;          
        }
    }
}

void aig_maj_a(void)
{
    byte i, uln, l293d, g;

    if(aig_step == AIG_NOP)
    {
        //recherche d'un aiguillage a deplacer
        for(i = 0; i < AIG_MAX; i++)
        {
             if(aig_no == AIG_MAX) aig_no = 0;
             if((aig_data[aig_no] & 0x0070) == 0) { aig_no++; continue; } //aiguillage non utilise
             if((aig_data[aig_no] & 0x0007) == 2 || (aig_data[aig_no] & 0x0007) == 5) { aig_no++; continue; } // continuer si positionement normal (cmd=0 et pos0=1 et pos1==0) ou (cmd=1 et pos0=0 et pos1==1)
             // aiguillage a manoeuvrer
             aig_on_module = (aig_data[aig_no] >> 8) & 0x007f;
             if(aig_data[aig_no] & 8) aig_move_srv = 1; else aig_move_srv = 0;

             if((aig_move_srv == 0) && (aig_on_module > 96)) continue;
             if((aig_move_srv == 1) && (aig_on_module > 48)) continue;
             
             aig_step = AIG_PREP;
             aig_timer = aig_prep;
             aig_cmd = aig_data[aig_no] & 1;
             aig_data[aig_no] &= 0xfff9;   //effacement de pos0 et pos1 durant la manoeuvre

             // faire l'action de preparation
             if(aig_move_srv==0) aig_4094_0 = aig_4094_1 = aig_4094_2 = aig_4094_3 = 0;
                         
             break;
        }
    }  
    if(aig_step == AIG_NOP) return; //tous les aiguillages sont bons
    
    if(aig_move_srv == 1) { aig_maj_s(); return; }
    
    if(aig_step == AIG_PREP)
    {
        if(aig_timer) aig_timer--;
        else
        {
             aig_step = AIG_GO;
             switch((aig_data[aig_no] >> 4) & 0x0007)
             {
                  case 1:  aig_timer =  1; break; // 125ms
                  case 2:  aig_timer =  2; break; // 250ms
                  case 3:  aig_timer =  4; break; // 500ms
                  case 4:  aig_timer =  8; break; // 1s
                  case 5:  aig_timer = 16; break; // 2s
                  case 6:  aig_timer = 40; break; // 5s
                  case 7:  aig_timer = 80; break; // 10s
                  default: aig_timer =  1; break; // 125ms   Ne devrait pas arriver car 0=aig non utilise
             }                  
             
             // faire l'action de go
             uln = 1 << (aig_on_module & 7);
             g = aig_on_module / 8; if(g >= 6) g -= 6;  // group 0-11 -> 0-5
             l293d = 4 << g;
             if(aig_cmd == 0)
                 l293d |= 1;                 
             else
                 l293d |= 2;
             if(aig_data[aig_no] & 0x80)   //inv
                 l293d ^= 3;              
             if(aig_on_module < 48)
             {
                 aig_4094_0 = uln;
                 aig_4094_1 = l293d;
                 aig_4094_2 = 0; 
                 aig_4094_3 = 0; 
             }
             else
             {
                 aig_4094_0 = 0; 
                 aig_4094_1 = 0; 
                 aig_4094_2 = uln;
                 aig_4094_3 = l293d;
             }
        }
    }

    if(aig_step == AIG_GO)
    {
        if(aig_timer) aig_timer--;
        else
        {
             aig_step = AIG_LIB;
             aig_timer = aig_lib;
             // faire l'action de lib
             aig_4094_0 = aig_4094_1 = aig_4094_2 = aig_4094_3 = 0;
        }
    }

    if(aig_step==AIG_LIB)
    {
        if(aig_timer) aig_timer--;
        else
        {
             aig_step = AIG_NOP;
             aig_data[aig_no] &= 0xfff9;      //x,x,x,x,x,x,x,x, x,x,x,x,x,pos1=0,pos0=0,x
             if(aig_cmd == 0)
                  aig_data[aig_no] |= 0x0002;   // pos1=0 pos0=1
             else
                  aig_data[aig_no] |= 0x0004;   // pos1=1 pos0=0
             // faire l'action de nop
             aig_4094_0 = aig_4094_1 = aig_4094_2 = aig_4094_3 = 0;
             aig_no++;
        }
    }
}

void aig_maj_b(void)
{
    byte i;

    if(aig_step == AIG_NOP)
    {
        //recherche d'un aiguillage a deplacer
        for(i = 0; i < AIG_MAX; i++)
        {
             if(aig_no == AIG_MAX) aig_no = 0;
             if((aig_data[aig_no] & 0x0070) == 0) { aig_no++; continue; } //aiguillage non utilise
             if((aig_data[aig_no] & 0x0007) == 2 || (aig_data[aig_no] & 0x0007) == 5) { aig_no++; continue; } // continuer si positionement normal (cmd=0 et pos0=1 et pos1==0) ou (cmd=1 et pos0=0 et pos1==1)
             // aiguillage a manoeuvrer
             aig_on_module = (aig_data[aig_no] >> 8) & 0x007f;
             if(aig_data[aig_no] & 8) aig_move_srv = 1; else aig_move_srv = 0;

             if((aig_move_srv == 0) && (aig_on_module > 16)) continue;
             if((aig_move_srv == 1) && (aig_on_module > 48)) continue;

             aig_step = AIG_PREP;
             aig_timer = aig_prep;
             aig_cmd = aig_data[aig_no] & 1;
             aig_data[aig_no] &= 0xfff9;   //effacement de pos0 et pos1 durant la manoeuvre

             // faire l'action de preparation
             if(aig_move_srv == 0)
             {
                 aig_GD3210 = (aig_on_module & 15);  // Sel
                 if(aig_cmd)
                     aig_GD3210 |= 0x10;   // Dev              
                 if(aig_data[aig_no] & 0x80) // inv
                     aig_GD3210 ^= 0x10;                 
             }
             break;
        }
    }  
    if(aig_step == AIG_NOP) return; //tous les aiguillages sont bons
    
    if(aig_move_srv==1) { aig_maj_s(); return; }
   
    if(aig_step == AIG_PREP)
    {
        if(aig_timer) aig_timer--;
        else
        {
             aig_step = AIG_GO;
             switch((aig_data[aig_no] >> 4) & 0x0007)
             {
                  case 1:  aig_timer =  1; break; // 125ms
                  case 2:  aig_timer =  2; break; // 250ms
                  case 3:  aig_timer =  4; break; // 500ms
                  case 4:  aig_timer =  8; break; // 1s
                  case 5:  aig_timer = 16; break; // 2s
                  case 6:  aig_timer = 40; break; // 5s
                  case 7:  aig_timer = 80; break; // 10s
                  default: aig_timer =  1; break; // 125ms   Ne devrait pas arriver car 0=aig non utilise
             }                  
             
             // faire l'action de go
             aig_GD3210 |= 0x20;       // Go          
        }
    }

    if(aig_step == AIG_GO)
    {
        if(aig_timer) aig_timer--;
        else
        {
             aig_step = AIG_LIB;
             aig_timer = aig_lib;
             // faire l'action de lib
             aig_GD3210 &= 0x1f;   // fin Go          
        }
    }

    if(aig_step == AIG_LIB)
    {
        if(aig_timer) aig_timer--;
        else
        {
             aig_step = AIG_NOP;
             aig_data[aig_no] &= 0xfff9;      //x,x,x,x,x,x,x,x, x,x,x,x,x,pos1=0,pos0=0,x
             if(aig_cmd==0)
                  aig_data[aig_no] |= 0x0002;   // pos1=0 pos0=1
             else
                  aig_data[aig_no] |= 0x0004;   // pos1=1 pos0=0

             // faire l'action de nop
             aig_GD3210 = 0;
             aig_no++;
        }
    }

#if use_inv_aig_direct_cmd == 0
    if(aig_GD3210&0x08) digitalWrite(PIN_AIGS3, HIGH); else digitalWrite(PIN_AIGS3, LOW);
    if(aig_GD3210&0x04) digitalWrite(PIN_AIGS2, HIGH); else digitalWrite(PIN_AIGS2, LOW);
    if(aig_GD3210&0x02) digitalWrite(PIN_AIGS1, HIGH); else digitalWrite(PIN_AIGS1, LOW);
    if(aig_GD3210&0x01) digitalWrite(PIN_AIGS0, HIGH); else digitalWrite(PIN_AIGS0, LOW);
    if(aig_GD3210&0x10) digitalWrite(PIN_AIGDR, HIGH); else digitalWrite(PIN_AIGDR, LOW);
    if(aig_GD3210&0x20) digitalWrite(PIN_AIGGO, HIGH); else digitalWrite(PIN_AIGGO, LOW);
#endif    
#if use_inv_aig_direct_cmd == 1
    if(aig_GD3210&0x08) digitalWrite(PIN_AIGS3, LOW); else digitalWrite(PIN_AIGS3, HIGH);
    if(aig_GD3210&0x04) digitalWrite(PIN_AIGS2, LOW); else digitalWrite(PIN_AIGS2, HIGH);
    if(aig_GD3210&0x02) digitalWrite(PIN_AIGS1, LOW); else digitalWrite(PIN_AIGS1, HIGH);
    if(aig_GD3210&0x01) digitalWrite(PIN_AIGS0, LOW); else digitalWrite(PIN_AIGS0, HIGH);
    if(aig_GD3210&0x10) digitalWrite(PIN_AIGDR, LOW); else digitalWrite(PIN_AIGDR, HIGH);
    if(aig_GD3210&0x20) digitalWrite(PIN_AIGGO, LOW); else digitalWrite(PIN_AIGGO, HIGH);
#endif    
}



//------------------------------------------------------------------------------
// EFFETS SPECIAUX
//------------------------------------------------------------------------------

// FX est une zone ou l'utilisateur peut faire des effets speciaux
// Les effets speciaux sont principalement indiques pour les LEDs et NEOs
// le tableau io_fx contient les commandes pour les effets speciaux (64 max)

#define FX_MAX (64/8)
byte io_fx[FX_MAX];

byte fx_cpt=0;

// fonction d'aide pour jouer avec les leds
void led_on_off(byte num, byte val)
{
    if(val) io_led[num/8] |=  (1 << (num & 7));  
    else    io_led[num/8] &= ~(1 << (num & 7));
}

// fonction d'aide pour lire la commande d'un effet special
byte is_fx(byte num)
{
    if(num > 64) return 0;

    if(io_fx[num / 8] & (1 << (num & 7))) return 1;
    return 0;
}


// <<<<<<<<<<< Debut des fonctions utilisateurs des effets speciaux FX

// Fonction simule en permanence un feu de cheminee sur le neopixel 0
void fx_neo0_cheminee(void)
{
    byte r = random(50, 80);
    byte v = random(0, 30);
    
    neo_rvb[0][NEO_R] = r;
    neo_rvb[0][NEO_V] = v;
    neo_rvb[0][NEO_B] = 0;
}

// Fonction qui simule une TV sur le neopixel 1 lorsque l'effet special 0 est demande
void fx_neo1_tv(void)
{
    if(is_fx(0) == 0) return;
    
    neo_rvb[1][NEO_R] = 0;
    neo_rvb[1][NEO_V] = random(10, 80);
    neo_rvb[1][NEO_B] = random(10, 80);
}

// Fonction qui simule en permanence le scintillement d'un neon sur le neopixel 2
void fx_neo2_scintillement(void)
{
    byte w = random(21, 29);

    neo_rvb[2][NEO_R] = neo_rvb[2][NEO_V] = neo_rvb[2][NEO_B] = w;
}

// Fonction qui simule le scintillement d'un neon sur le neopixel 3
// avec en plus un effet neon cassé (extinction de temps en temps du neopixel)
byte neo3_neonkc_step = 0;
byte neo3_neonkc_dcpt = 0;
//                step     0  1  2  3  
//                led      H     H       H=led allumee   
byte neo3_neonkc_t[]  = { 80, 3, 2, 1};  // ces valeurs sont a multiplier par 125ms, soit 10s,375ms,500ms,125ms
void fx_neo3_neonkc(void)
{
    if(neo3_neonkc_step == 1 || neo3_neonkc_step == 3)
        neo_rvb[3][NEO_R] = neo_rvb[3][NEO_V] = neo_rvb[3][NEO_B] = 0; // extinction step 1 et 3
    else
        neo_rvb[3][NEO_R] = neo_rvb[3][NEO_V] = neo_rvb[3][NEO_B] = random(20, 30); // scintillement step 0 et 2
    
    if(neo3_neonkc_dcpt) neo3_neonkc_dcpt--;
    if(neo3_neonkc_dcpt) return;
    neo3_neonkc_step++;
    if(neo3_neonkc_step == 4) neo3_neonkc_step = 0;
    neo3_neonkc_dcpt = neo3_neonkc_t[neo3_neonkc_step];

    //au lieu d'utiliser 40*125=5s comme specifie dans le tableau, on utilise un temps variable (entre 5 et 10s)
    if(neo3_neonkc_step == 0) neo3_neonkc_dcpt = random(40, 80);  
}

// Fonction qui simule un arc sur le neopixel 4 lorsque l'effet special 8 est demande
byte neo4_arc_step = 0;
byte neo4_arc_dcpt = 0;
//             step  0  1  2  3  4  5  6  7  8  9  
//             led      H     H     H     H     H
byte neo4_arc_t[]  = { 80, 1, 1, 1, 2, 6, 2, 4, 2, 1 };  // ces valeurs sont a multiplier par 125ms
void fx_neo4_arc(void)
{
    if(neo4_arc_step == 0 && is_fx(8) == 0) return;

    neo_rvb[4][NEO_R] = neo_rvb[4][NEO_V] = 0;
    if(neo4_arc_step & 1) neo_rvb[4][NEO_B] = random(100, 255);  //neo4_arc_step&1 est vrai pour tous les nombres impairs 1,3...
    else                  neo_rvb[4][NEO_B] = 0;

    if(neo4_arc_dcpt) neo4_arc_dcpt--;
    if(neo4_arc_dcpt) return;
    neo4_arc_step++;
    if(neo4_arc_step == 10) neo4_arc_step = 0;
    neo4_arc_dcpt = neo4_arc_t[neo4_arc_step];  
}

// Fonction qui simule une soudure a l'arc sur la led 0 lorsque l'effet special 2 est demande
// La sequence est: 2 petits arcs de 125ms, puis 2 gros de 1s, pui un dernier petit avant une pause de 10s
byte led0_arc_step = 0;
byte led0_arc_dcpt = 0;
//             step  0  1  2  3  4  5  6  7  8  9  
//             led      H     H     H     H     H
byte led0_arc_t[]  = { 80, 1, 1, 1, 2, 6, 2, 4, 2, 1 };  // ces valeurs sont a multiplier par 125ms
void fx_led0_arc(void)
{
    if(led0_arc_step==0 && is_fx(2)==0) return;
    
    if(led0_arc_dcpt) led0_arc_dcpt--;
    if(led0_arc_dcpt) return;
    led0_arc_step++;
    if(led0_arc_step == 10) led0_arc_step = 0;
    led_on_off(0, led0_arc_step & 1); // allume la led sur les etats impairs 1,3...
    led0_arc_dcpt = led0_arc_t[led0_arc_step];  
}

// Fonction qui simule en permanence un neon cassé sur la led 1 (extinction de temps en temps de la led)
byte led1_neonkc_step = 0;
byte led1_neonkc_dcpt = 0;
//                step     0  1  2  3  
//                led      H     H       H=led allumee   
byte led1_neonkc_t[]  = { 40, 3, 2, 1};  // ces valeurs sont a multiplier par 125ms
void fx_led1_neonkc(void)
{
    if(led1_neonkc_step == 1 || led1_neonkc_step == 3) led_on_off(1, 0); // extinction step 1 et 3
    else                                               led_on_off(1, 1); // allumage   step 0 et 2
    
    if(led1_neonkc_dcpt) led1_neonkc_dcpt--;
    if(led1_neonkc_dcpt) return;
    led1_neonkc_step++;
    if(led1_neonkc_step == 4) led1_neonkc_step = 0;
    led1_neonkc_dcpt = led1_neonkc_t[led1_neonkc_step];

    //au lieu d'utiliser 40*125=5s comme specifie dans le tableau, on utilise un temps variable (entre 5 et 10s)
    if(led1_neonkc_step == 0) led1_neonkc_dcpt = random(40, 80);  
}

// Fonction qui simule le scintillement d'un neon sur la sortie pwm48 si l'effet special 5 est active
void fx_pwm48_scintillement(void)
{
    if(is_fx(5) == 0) return;
    
    io_pwm[48] = random(21, 29);
}

// Fonction qui simule un arc sur la pwm49 si l'effet special 9 est active
byte pwm49_arc_step = 0;
byte pwm49_arc_dcpt = 0;
//              step  0  1  2  3  4  5  6  7  8  9  
//              led      H     H     H     H     H
byte pwm49_arc_t[]  = { 80, 1, 1, 1, 2, 6, 2, 4, 2, 1 };  // ces valeurs sont a multiplier par 125ms
void fx_pwm49_arc(void)
{
    if(pwm49_arc_step == 0 && is_fx(9) == 0) return;

    if(pwm49_arc_step&1) io_pwm[49] = random(100,255);  //pwm49_arc_step&1 est vrai pour tous les nombres impairs 1,3...
    else                 io_pwm[49] = 0;

    if(pwm49_arc_dcpt) pwm49_arc_dcpt--;
    if(pwm49_arc_dcpt) return;
    pwm49_arc_step++;
    if(pwm49_arc_step == 10) pwm49_arc_step = 0;
    pwm49_arc_dcpt = pwm49_arc_t[pwm49_arc_step];  
}

// <<<<<<<<<<< Fin des fonctions utilisateurs des effets speciaux FX


// Cette fonction est uniquement appellee a l'initialisation
void fx_init(void)
{
    randomSeed(TCNT2);  // initialisation des generateurs aleatoires
}

// Cette fonction est appelee toute les 125ms. Appellez vos fonctions ici
void fx_maj(void)
{
    fx_cpt++;

    //fx_neo0_cheminee();
    //fx_neo1_tv();
    //fx_neo2_scintillement();
    //fx_neo3_neonkc();
    //fx_neo4_arc();

    //fx_led0_arc();
    //fx_led1_neonkc();

    //fx_pwm48_scintillement();
    //fx_pwm49_arc();
}



//------------------------------------------------------------------------------
// LIAISON SERIE
//------------------------------------------------------------------------------

// A) liaison serie maison (non utilisee car la liaison serie standard suffit)

void seriel_init(void)
{
     UBRR0H = 0; 
     UBRR0L = 103;     // 9600bps  u2x=0 qz=16Mhz
     UCSR0B = (1<<RXEN0)|(1<<TXEN0);
     UCSR0C = (1<<UCSZ00)|(1<<UCSZ01); //8bits 1stop 0parity
}

void seriel_tx(unsigned char data)
{
     while(!(UCSR0A & (1<<UDRE0)));
     UDR0 = data;
}

unsigned char seriel_rx(void)
{
     while(!(UCSR0A & (1<<RXC0)));
     return UDR0;
}

unsigned char seriel_isrx(void)
{
     if (UCSR0A & (1<<RXC0)) return 1;
     return 0;
}


// B) Initialisation de la liaison serie 
void serial_init(void)
{
  // dans setup pour l'instant.
}


// C) protocole "UU" de communication avec un ordinateur

/* Commandes du protocol "UU" (toute autre commande recue est sans effet) */
#define RS232_CMD_PING     0x00   // PING      0x00 -> 0x83
#define RS232_CMD_VERS     0x01   // VERS      0x00 -> 16 octets d'information (0x84...............)

#define RS232_CMD_INIT     0x78   // INIT      0x78 + 0.0.CLRIN.AIG.PHA.CLI.LED.OUT
#define RS232_CMD_CFG      0x79   // CFG       0x79 + action(2=aig_off, 3=aig_on)
#define RS232_CMD_AU0      0x70   // AU#       0x70
#define RS232_CMD_AU1      0x71   // AU        0x71
#define RS232_CMD_AUGET    0x72   // AUGET     0x72 -> AU

#define RS232_CMD_LOCO     0x10   // LOCO      0x10 + ADR(1-50)  + VIT(xxS[0-28])  + FCT (xxxF4F3F2F1F0)
#define RS232_CMD_LOCOIN   0x11   // LOCO-IN   0x11 + ADR(1-50) -> VIT(xxS[0-28]) -> FCT (xxxF4F3F2F1F0)
#define RS232_CMD_LOCOPGM  0x12   // LOCOPGM   0x12 + 0x55 + 0xAA ++ CV(1-1024) + DAT(0-255)
#define RS232_CMD_LOCOMODE 0x13   // LOCOMODE  0x13 + mode (0=DCC, 1=ANALOGIQE, 2=0, 3=1)

#define RS232_CMD_MOUSE    0x60   // MOUSE     0x60 + #mou(0-9) + adr    (ne fait plus: + vit + fct)
#define RS232_CMD_MOUSEIN  0x61   // MOUSE-IN  0x61 + #mou(0-9) -> adr                  (adr.bit7=disconnected)
#define RS232_CMD_MOUSEIN2 0x62   // MOUSE-IN2 0x62 + #mou(0-9) -> adr -> vit -> fct    (adr.bit7=disconnected)

#define RS232_CMD_AIGDIR   0x20   // AIG-DIR  0x20 + #aig(0-95)
#define RS232_CMD_AIGDEV   0x21   // AIG-DEV  0x21 + #aig(0-95)
#define RS232_CMD_AIGPOS   0x22   // AIG-POS  0x21 + #aig -> T1.N6.N5.N4.N3.N2.N1.N0 + inv.pulsems(3bits).T0.pos1.pos0.cmd

#define RS232_CMD_OUT0     0x30   // OUT-OFF  0x30 + #out(0-63)
#define RS232_CMD_OUT1     0x31   // OUT-ON   0x31 + #out(0-63)
#define RS232_CMD_PWM      0x32   // PWM      0x32 + #pwm(0-51) + val   #0..47=I2C 48=pwm0..51=pwm3
#define RS232_CMD_SRV      0x33   // SRV      0x33 + #srv(0-47) + val   #0..47=I2C

#define RS232_CMD_LEDOFF   0x40   // LED-OFF  0x40 + #led(0-255)
#define RS232_CMD_LEDON    0x41   // LED-ON   0x41 + #led(0-255)
#define RS232_CMD_LEDCLI0  0x42   // LED-CLI0 0x42 + #led(0-255)
#define RS232_CMD_LEDCLI1  0x43   // LED-CLI1 0x43 + #led(0-255)
#define RS232_CMD_LEDPHA0  0x44   // LED-PHA0 0x44 + #led(0-255)
#define RS232_CMD_LEDPHA1  0x45   // LED-PHA1 0x45 + #led(0-255)
#define RS232_CMD_FX0      0x46   // FX-OFF   0x46 + #fx(0-63)
#define RS232_CMD_FX1      0x47   // FX-ON    0x47 + #fx(0-63)
#define RS232_CMD_NEO      0x48   // NEO      0x48 + #neo(0-59) + R + V + B

#define RS232_CMD_IN       0x50   // IN       0x50 -> in7..0 -> in15..8 -> ... -> in 255..248
#define RS232_CMD_INMEM    0x51   // IN-MEM   0x51 "
#define RS232_CMD_INMCLR   0x53   // IN-MCLR  0x53 "
#define RS232_CMD_AN       0x58   // AN       0x58 + #an(0-11) -> val   //0-11:mouses 10=AN0 11=AN1

#define RS232_CMD_BYTE     0x49   // BYTE     0x49 + #byte + val   //uu: voir si  on  a besoin de lire
#define RS232_CMD_BIT      0x4a   // BIT      0x4a + #bit  + val

unsigned char arg0;
unsigned char arg1;
unsigned char arg2;
unsigned char arg3;
unsigned char arg4;
unsigned char step = 0;
unsigned char serial_err = 0;

#if use_centraleA == 1
    #define NB_S88_8bits 32   //256entrees
    #define VERS 'A'
#endif    
#if use_centraleB == 1
    #define NB_S88_8bits 6    // 20entrees = 4 xxxDDDDD+xxxDDDDD+xxxDDDDD+xxxDDDDD (20/32) ou 25entrees = 5 ou 30entrees = 6
    #define VERS 'B'
#endif    


void serialuu_maj_cmd(byte cmd)
{
    unsigned char tmp, d, i, adr, num, bit;
    unsigned int cv_adr;
 
    if(step == 0) 
    {
        arg0 = cmd;
        switch(arg0)
        {
            case RS232_CMD_PING    : Serial.write(0x83); break;
            case RS232_CMD_VERS    : Serial.write(0x84); Serial.write(1);   // 0x84=protocolUU 1=v1
                                     Serial.write(VERS); Serial.write(1);   // VERS=typecentrale'A'ou'B' 1=v1
                                     Serial.write(num_centrale);            // numero centrale
                                     Serial.write(50);                      // 50ch DCC
                                     Serial.write(NB_S88_8bits);            // IN/8
                                     Serial.write(AIG_MAX);                 // AIGS 
                                     Serial.write(64);                      // OUT
                                     Serial.write(32);                      // LED/8
                                     Serial.write(52);                      // PWM
                                     Serial.write(60);                      // NEO 
                                     Serial.write(48);                      // SRV 
                                     Serial.write(0);                       // spare 
                                     Serial.write(0);                       // spare
                                     Serial.write(0);                       // spare
                                     break;

            case RS232_CMD_AU0     : dcc_au = 0; break;
            case RS232_CMD_AU1     : dcc_au = 1; break;
            case RS232_CMD_AUGET   : Serial.write(dcc_au); break;
            case RS232_CMD_IN      : for(i = 0; i < NB_S88_8bits; i++) Serial.write(io_in[i]); break;
            case RS232_CMD_INMEM   : for(i = 0; i < NB_S88_8bits; i++) Serial.write(io_inmem[i]); break;
            case RS232_CMD_INMCLR  : for(i = 0; i < NB_S88_8bits; i++) { tmp = io_inmem[i]; io_inmem[i] = 0; Serial.write(tmp); } break;

            case RS232_CMD_INIT    :
            case RS232_CMD_CFG     :

            case RS232_CMD_LOCO    :
            case RS232_CMD_LOCOIN  :
            case RS232_CMD_LOCOPGM :
            case RS232_CMD_LOCOMODE:

            case RS232_CMD_OUT0    :
            case RS232_CMD_OUT1    :
            case RS232_CMD_PWM     :
            case RS232_CMD_SRV     :
              
            case RS232_CMD_LEDOFF  :
            case RS232_CMD_LEDON   :
            case RS232_CMD_LEDCLI0 :
            case RS232_CMD_LEDCLI1 :
            case RS232_CMD_LEDPHA0 :
            case RS232_CMD_LEDPHA1 :
            case RS232_CMD_FX0     :
            case RS232_CMD_FX1     :
            case RS232_CMD_NEO     :
                
            case RS232_CMD_AIGDIR  :
            case RS232_CMD_AIGDEV  :
            case RS232_CMD_AIGPOS  :
                
            case RS232_CMD_MOUSE   :
            case RS232_CMD_MOUSEIN :
            case RS232_CMD_MOUSEIN2: 

            case RS232_CMD_BYTE    :
            case RS232_CMD_BIT     :

            case RS232_CMD_AN      :
                                     step++; break;
                
            default: serial_err++; break;
        }     
    }
    
    else
    {
        if(step == 1) arg1 = cmd;
        if(step == 2) arg2 = cmd;
        if(step == 3) arg3 = cmd;
        if(step == 4) arg4 = cmd;
        num = arg1 / 8;
        bit = 1 << (arg1 & 7);
            
        switch(arg0)
        {
            case RS232_CMD_LOCO:
                // arg1 = adr
                // arg2 = vit
                // arg3 = fct
                if(step == 3)
                {                                            
                    if(arg1 > 50) arg1 = 0;
                    dcc.update_loc_sens_vit_fct(arg1, (arg2>>5)&1, arg2 & 0x1f, arg3);
                    step = 0;                
                }
                break;

            case RS232_CMD_LOCOIN:
                // arg1 = adr
                if(arg1>50) arg1 = 0;
                d = dcc.get_vit(arg1);
                if(dcc.get_sens(arg1)) d |= 0x20;
                Serial.write(d);                                                                                 
                d = dcc.get_fct43210(arg1);
                Serial.write(d);                                              
                step = 0;
                break;

            case RS232_CMD_LOCOPGM:  // LOCOPGM   0x12 + 0x55 + 0xAA ++ CV(1-1024) + DAT(0-255)
                // arg1 = 0x55
                // arg2 = 0xAA
                // arg3 = CV_h
                // arg4 = CV_l
                // cmd  = DAT                                         
                if(step == 5)  
                {
                    cv_adr  = arg3;
                    cv_adr  = cv_adr << 8;
                    cv_adr |= arg4;
                    if(arg1 == 0x55 && arg2 == 0xAA) dcc.prog_cv(cv_adr, cmd);
                    step = 0;
                }
                break;
            
            case RS232_CMD_LOCOMODE:  // LOCOMODE  0x13 + mode (0=DCC, 1=ANALOGIQE, 2=0, 3=1)   uu: passer en cmd
                //arg1 = dcc_mode
                //dcc_mode = arg1
                step = 0;                      
                break;

            case RS232_CMD_OUT0   : if(arg1 < 64) io_out[num] &= ~bit; step=0; break;
            case RS232_CMD_LEDOFF : io_led[num] &= ~bit; step=0; break;
            case RS232_CMD_LEDCLI0: io_cli[num] &= ~bit; step=0; break;
            case RS232_CMD_LEDPHA0: io_pha[num] &= ~bit; step=0; break;
  
            case RS232_CMD_OUT1   : if(arg1 < 64) io_out[num] |= bit; step=0; break;
            case RS232_CMD_LEDON  : io_led[num] |= bit; step=0; break;
            case RS232_CMD_LEDCLI1: io_cli[num] |= bit; step=0; break;
            case RS232_CMD_LEDPHA1: io_pha[num] |= bit; step=0; break;

            case RS232_CMD_FX0    : if(arg1 < 64) io_fx[num] &= ~bit; step=0; break;
            case RS232_CMD_FX1    : if(arg1 < 64) io_fx[num] |=  bit; step=0; break;

            case RS232_CMD_PWM:
                // arg1 = pwm#
                // arg2 = value
                if(step == 2) 
                {
                     if(arg1 < 52) io_pwm[arg1] = arg2;
                     step = 0;
                }
                break;
                    
            case RS232_CMD_SRV:
                // arg1 = srv#
                // arg2 = value
                if(step == 2) 
                {
                     if(arg1 < 48) if(io_srv_aig[arg1] == 0) io_srv_cmd[arg1] = arg2;
                     step = 0;
                }
                break;

            case RS232_CMD_NEO:
                // arg1 = neo#
                // arg2 = R
                // arg3 = V
                // arg4 = B
                if(step == 4)
                { 
                    if(arg1<60)
                    {
                        neo_rvb[arg1][NEO_R] = arg2;
                        neo_rvb[arg1][NEO_V] = arg3;
                        neo_rvb[arg1][NEO_B] = arg4;
                    }
                    step = 0;
                }
                break;
                    
            case RS232_CMD_BYTE:
                // arg1 = byte#
                // arg2 = val
                if(step == 2)
                {
                    // if(arg1<10) special_byte[arg1] = arg2;           
                    step = 0;
                }
                break;

            case RS232_CMD_BIT:
                // arg1 = bit#
                // arg2 = val
                if(step == 2)
                {
                    // if(arg1<64)
                    // {
                    //    num = arg1/8;
                    //    bit = 1<<(arg1&7);
                    //    if(arg2) special_bit[num] |= bit; 
                    //    else     special_bit[num] &= ~bit; 
                    // }
                    step = 0;
                }
                break;

            case RS232_CMD_INIT:
                // arg1 = 0.DCC.CLRIN.AIG.PHA.CLI.LED.OUT
                if(arg1 & 1) for(i = 0; i <  8; i++) io_out[i] = 0;
                if(arg1 & 1) for(i = 0; i < 52; i++) io_pwm[i] = 0;
                if(arg1 & 1) for(i = 0; i < 48; i++) io_srv_cmd[i] = 150;
                if(arg1 & 2) for(i = 0; i < 32; i++) io_led[i] = 0;
                if(arg1 & 4) for(i = 0; i < 32; i++) io_cli[i] = 0;
                if(arg1 & 8) for(i = 0; i < 32; i++) io_pha[i] = 0;
                if(arg1 & 0x10) for(i = 0; i < AIG_MAX; i++) aig_data[i] &= 0xfff8;  //aig cmd repos cmd=0 pos1=0 pos0=0
                if(arg1 & 0x20) for(i = 0; i < 32; i++) io_in[i] = io_inmem[i] = 0;
                //if(cmd & 0x40) dcc_init();  //vitesse et fct nulles
                step = 0; break;
                    
            case RS232_CMD_CFG:
                // arg1 = 
                // 2 = aig_off
                // 3 = aig_on
                if(arg1 == 2) { aig_wait_10s = 0; aig_on = 0; }
                if(arg1 == 3) { aig_wait_10s = 0; aig_on = 1; }
                step = 0; break;

            case RS232_CMD_AN: 
                // arg1 = can#
                if(arg1 < 12) Serial.write(can[arg1]); else Serial.write(0);
                step = 0; break;
            
            case RS232_CMD_AIGDIR:
                // arg1 = aig#
                if(arg1 < AIG_MAX) aig_data[arg1] &= 0xfffe;  //clr cmd 
                step = 0; break;
            case RS232_CMD_AIGDEV:
                // arg1 = aig#
                if(arg1 < AIG_MAX) aig_data[arg1] |= 0x0001;  //set cmd 
                step = 0; break;
            case RS232_CMD_AIGPOS:            
                // arg1 = aig#
                if(arg1 < AIG_MAX) { Serial.write(aig_data[arg1] >> 8); Serial.write(aig_data[arg1] & 255); }
                else               { Serial.write(0);                   Serial.write(0);                    }
                step = 0; break;
            
            case RS232_CMD_MOUSE: 
                // arg1 = mouse#
                // arg2 = adr
                if(step == 2)
                {
                    if(arg1 < 10) if(arg2 <= 50) mouse[arg1].adr = arg2;
                    step = 0;
                }
                break;
                            
            case RS232_CMD_MOUSEIN:
                // arg1 = mouse#
                if(arg1 <= 9) 
                {
                    adr = mouse[arg1].adr;
                    if(adr > 50) adr = 0;
                    if(can[arg1] > 250) adr |= 0x80;
                }
                else
                {
                    adr = 0 + 0x80;
                }
                Serial.write(adr);  //tx adr
                step = 0; break;
                                               
            case RS232_CMD_MOUSEIN2:
                // arg1 = mouse#
                if(arg1<=9) 
                {
                    adr = mouse[arg1].adr;
                    if(adr > 50) adr = 0;
                    if(can[arg1] > 250) adr |= 0x80;
                }
                else 
                {
                    adr = 0 + 0x80;
                }
                Serial.write(adr);   //tx adr w disconnect flag
                adr = adr & 0x7f;
                if((adr) == 0) 
                {
                    Serial.write(0);   //VIT&FCT=0
                    Serial.write(0);
                }
                else
                {
                    d=dcc.get_vit(adr); if(dcc.get_sens(adr)) d |= 0x20; Serial.write(d);                                                                                 
                    d=dcc.get_fct43210(adr); Serial.write(d);
                }
                step = 0; break;            

            default: serial_err++; break;
        }  
        if(step) step++;
    } // if(step)
}


// D) protocole "6050 Marklin" de communication avec un ordinateur

// Titre           Codage 1er octet    2eme octet    Commentaires
// Vitesse         000.F0.VVVV         Adr loco      VVVV=0-14=vitesse   VVVV=15=inv de sens
// Fonctions       010.0.F4.F3.F2.F1   Adr loco      Adr=1-50 (80 ds le standard)
// Aig/Out/Led     001.000.R.V         Num Aig/Out   R=rouge/dévié/off V=Vert/droit/on
// AU              011.0000.AU                       AU=1=Arrêt d’urgence
// Lecture N S88   100.NNNNN -> entrées  NNNNN=Nb de S88 à lire   (0=mode sans eff)
// Lecture 1 S88   110.NNNNN -> entrées  NNNNN=Num du S88 à lire  (0=mode avec eff)

byte in6050mode=1; //avec effacement

void serial6050_maj_cmd(byte cmd)
{
    byte num, bit, i, tmp, sens, vit, fct;
 
    if(step == 0) 
    {
        arg0 = cmd;
            
        // AU
        if(     arg0 == 0x60) dcc_au = 0;            
        else if(arg0 == 0x61) dcc_au = 1;

        // Lecture N S88   100.NNNNN -> entrées  NNNNN=Nb de S88 à lire   (0=mode sans eff)
        else if((arg0 & 0xe0) == 0x80)
        {
            num = arg0 & 0x1f;
            if(num==0) in6050mode = 0; //mode sans effacement
            else
            {
                if(num > 16) num=16;
                num = 2 * num;  //cmd:16bits -> entrees:8bits
                for(i = 0; i < num; i++)
                { 
                    tmp = io_inmem[i];
                    if(in6050mode) io_inmem[i] = 0;
                    Serial.write(tmp);
                }
            }
        }
            
        // Lecture 1 S88   110.NNNNN -> entrées  NNNNN=Num du S88 à lire  (0=mode avec eff)
        else if((arg0 & 0xe0) == 0xC0)
        {
            num = arg0 & 0x1f;
            if(num==0) in6050mode = 1; //mode avec effacement
            else
            {
                if(num>16) num=16;
                num = num - 1;  //0-15  
                num = 2 * num;    //cmd:16bits -> entrees:8bits
                tmp=io_inmem[num];
                if(in6050mode) io_inmem[num] = 0;
                Serial.write(tmp);
                tmp = io_inmem[num + 1];
                if(in6050mode) io_inmem[num + 1] = 0;
                Serial.write(tmp);                    
            }
        }

        // Vitesse         000.F0.VVVV         Adr loco      VVVV=0-14=vitesse   VVVV=15=inv de sens
        else if((arg0 & 0xe0) == 0) step++;
         
        // Fonctions       010.0.F4.F3.F2.F1   Adr loco      Adr=1-50 (80 ds le standard)
        else if((arg0 & 0xf0) == 0x40) step++;

        // Aig/Out/Led     001.000.R.V         Num Aig/Out   R=rouge/dévié/off V=Vert/droit/on
        else if((arg0 & 0xfc) == 0x20) step++;

        // unknown
        else serial_err++;        
    }

    if(step == 1) 
    {
        step = 0;
        arg1 = cmd;

        // Vitesse         000.F0.VVVV         Adr loco      VVVV=0-14=vitesse   VVVV=15=inv de sens
        if((arg0 & 0xe0) == 0) if(arg1 >= 1 && arg1 <= 50)
        {
            sens = dcc.get_sens(arg1);
            vit = arg0 & 0x0f;
            if(vit == 15) 
            {
                dcc.update_loc_sens(arg1, sens ^ 1);
            }
            else
            {
                vit = 2 * vit;  //6050=14crans, fdcc=28crans
                dcc.update_loc_vit(arg1, vit);
            }

            fct = dcc.get_fct43210(arg1);
            fct &= 0xfe; if(arg0 & 0x10) fct |= 1;                
            dcc.update_loc_fct(arg1, fct);
        }
            
        // Fonctions       010.0.F4.F3.F2.F1   Adr loco      Adr=1-50 (80 ds le standard)
        if((arg0 & 0xf0) == 0x40) if(arg1 >= 1 && arg1 <= 50)  
        {
            fct = dcc.get_fct43210(arg1);   //xxx43210
            fct &= 0x1e;                    //xxx----0
            fct |= ((arg0 << 1) & 0x1e);    //4321 > 4321x > xxx43210
            dcc.update_loc_fct(arg1, fct);                     
        }

        // Aig/Out/Led     001.000.R.V         Num Aig/Out   R=rouge/dévié/off V=Vert/droit/on
        if((arg0 & 0xfc) == 0x20)
        {
            // Type         Adresses  Nb  Fonctionnement (octet 1 & octet 2)
            // Aiguillages  0-95      96  00100001 & 0   -> aig0 direct     pas besoin d'envoyer 00100000 pour
            //                            00100010 & 0   -> aig0 dévié      stopper l'impulsion car automatique
            if(arg1 <= 95)
            {
                if(arg0 & 1) aig_data[arg1] |= 0x0001;
                if(arg0 & 2) aig_data[arg1] &= 0xfffe;
            }
            // Sorties      96-127    32  00100001 & 100 -> out4=1
            //                            00100010 & 100 -> out4=0
            else if(arg1 <= 127)
            {
                arg1 -= 96; //0-31
                num  = arg1 / 8;
                bit  = 1 << (arg1 & 7); 
                if(arg0 & 1) io_out[num] |=  bit;
                else         io_out[num] &= ~bit;
                //if(arg0 & 2) io_out[32+num] |=  bit;
                //else         io_out[32+num] &= ~bit;
            }
            // LEDs         128-255   128 00100001 & 128 -> led0=1 
            //                            00100010 & 128 -> led0=0
            else
            {
                arg1 -= 128; //0-127
                num  = arg1 / 8;
                bit  = 1 << (arg1 & 7); 
                if(arg0 & 1) io_led[num] |=  bit;
                else         io_led[num] &= ~bit;
                //if(arg0 & 2) io_led[128+num] |=  bit;
                //else         io_led[128+num] &= ~bit;
            }
        }
    }
}


// Partie commune aux protocols

void serial_maj_cmd(byte cmd)
{
    #if use_UU == 1
       serialuu_maj_cmd(cmd);
    #endif    
    #if use_6050 == 1
       serial6050_maj_cmd(cmd);
    #endif    
}   

void serial_maj(void)
{
    int rcmd;
    unsigned char cmd;

    // commencer par le buffer hors IT
    while(serial_rx_during_neo_rd < serial_rx_during_neo_wr)
    {
        cmd = serial_rx_during_neo_buff[serial_rx_during_neo_rd];
        serial_rx_during_neo_rd++;
        serial_maj_cmd(cmd);
    }

    // poursuivre par le buffer "normal" sous IT
    while(Serial.available())
    {
        rcmd = Serial.read();
        if(rcmd < 0) return;
        cmd = (unsigned char)rcmd;
        serial_maj_cmd(cmd);
    }
}    




//------------------------------------------------------------------------------
// USER (ancienement TDV)
//------------------------------------------------------------------------------

// USER est une zone ou l'utilisateur peut faire des actions automatiques
// Par exemple affecter des sorties/leds... en fonction des entrees...

void user_init(void)
{
}

void user_loop(void)
{
    //ex: allumage led 5 si in 3 
    //if(io_in[3/8]&(1<<(3%8))) io_led[5/8]|=(1<<(5%8)); else io_led[5/8]&=~(1<<(5%8));

    //ex: feu d'un canton
    // led 10 = v
    // led 11 = r
    // led 12 = j
    // in   0 = occupation canton
    // in   1 = occupation canton suivant
    //
    //    io_led[11/8]&=~(1<<(11%8)); // extinction de toutes les leds
    //    io_led[12/8]&=~(1<<(11%8));
    //    io_led[13/8]&=~(1<<(11%8));
    //    if(     io_in[0/8]&(1<<(0%8))) io_led[11/8]|=(1<<(11%8));  //canton occupe = rouge
    //    else if(io_in[1/8]&(1<<(1%8))) io_led[12/8]|=(1<<(12%8));  //canton libre et canton suivant occupe = jaune
    //    else                           io_led[10/8]|=(1<<(10%8));  //canton libre et canton suivant libre = vert
}



//------------------------------------------------------------------------------
// MAIN (SETUP & LOOP)
//------------------------------------------------------------------------------

void setup() 
{
    Serial.begin(RS232_SPEED);  // Initialize serial communications with the PC
    while (!Serial) 
    {
    }
  
    pinMode(PIN_CLI  , OUTPUT); digitalWrite(PIN_CLI  , LOW);
#if use_centraleA == 1    
    pinMode(PIN_DIN  , INPUT ); digitalWrite(PIN_DIN  , LOW);
    pinMode(PIN_RST  , OUTPUT); digitalWrite(PIN_RST  , LOW);
    pinMode(PIN_PWM51, OUTPUT); digitalWrite(PIN_PWM51, LOW);
    pinMode(PIN_PWM50, OUTPUT); digitalWrite(PIN_PWM50, LOW);
    pinMode(PIN_LDIN , OUTPUT); digitalWrite(PIN_LDIN , LOW);
    pinMode(PIN_LDOUT, OUTPUT); digitalWrite(PIN_LDOUT, LOW);
#endif    
#if use_centraleB == 1    
    #if use_inv_aig_direct_cmd == 0
    pinMode(PIN_AIGS3, OUTPUT); digitalWrite(PIN_AIGS3, LOW);
    pinMode(PIN_AIGS2, OUTPUT); digitalWrite(PIN_AIGS2, LOW);
    pinMode(PIN_AIGS1, OUTPUT); digitalWrite(PIN_AIGS1, LOW);
    pinMode(PIN_AIGS0, OUTPUT); digitalWrite(PIN_AIGS0, LOW);
    pinMode(PIN_AIGDR, OUTPUT); digitalWrite(PIN_AIGDR, LOW);
    pinMode(PIN_AIGGO, OUTPUT); digitalWrite(PIN_AIGGO, LOW);
    #endif
    #if use_inv_aig_direct_cmd == 1
    pinMode(PIN_AIGS3, OUTPUT); digitalWrite(PIN_AIGS3, HIGH);
    pinMode(PIN_AIGS2, OUTPUT); digitalWrite(PIN_AIGS2, HIGH);
    pinMode(PIN_AIGS1, OUTPUT); digitalWrite(PIN_AIGS1, HIGH);
    pinMode(PIN_AIGS0, OUTPUT); digitalWrite(PIN_AIGS0, HIGH);
    pinMode(PIN_AIGDR, OUTPUT); digitalWrite(PIN_AIGDR, HIGH);
    pinMode(PIN_AIGGO, OUTPUT); digitalWrite(PIN_AIGGO, HIGH);
    #endif
#endif
    init_srv_slow();
#if use_i2c == 0    
    pinMode(PIN_PWM49, OUTPUT); digitalWrite(PIN_PWM49, LOW);
    pinMode(PIN_PWM48, OUTPUT); digitalWrite(PIN_PWM48, LOW);
#else
    i2c_init();
#endif    
    pinMode(PIN_LDLED, OUTPUT); digitalWrite(PIN_LDLED, LOW);
    pinMode(PIN_DOUT , OUTPUT); digitalWrite(PIN_DOUT , HIGH);  //pr centrale B afin de desactiver les colonnes
    pinMode(PIN_CLK  , OUTPUT); digitalWrite(PIN_CLK  , HIGH);  //"

    digitalWrite(A0, LOW); pinMode(A0, OUTPUT);   //DCC
#if use_DCCB == 1
    digitalWrite(A1, LOW); pinMode(A1, OUTPUT);   //DCCB
#endif
#if use_DCCB == 0
    digitalWrite(A1,HIGH);
#endif
    digitalWrite(A2,HIGH);
    digitalWrite(A3,HIGH);
    digitalWrite(A4,HIGH);
    digitalWrite(A5,HIGH);

    mouse_init();
    in_init();
    aig_init();
    out_init();
    led_init();
    cli_init();
    alim_analog_init();
    pwm_init();
    dcc.init();
    sei();          // Enable interrupts 
    neo_init();     //a faire ici car pour dcc::stop les it doivent etre activees, sinon dead lock
    fx_init();
    user_init();

    //dcc.update_loc_sens_vit_fct( 5, 1, 28, 1);
    //dcc.prog_cv(1, 8);
}

void loop() 
{
    while(flag_62ms5==0) {}
    flag_62ms5 = 0;
    cpt_125ms++;
    if(cpt_125ms == 80) if(aig_wait_10s)
        aig_on=1;
  
    maj_can();  //Serial.print("can0="); Serial.println(can[0]);
    //debug_can(); //uu
    mouse_maj();
    dcc.maj_dcc_liste();
  
    #if use_centraleA == 1
        in_maj_a();  
        user_loop();
        if(aig_on) aig_maj_a();  //deplacement des aiguillages a partir de 10s
        out_maj();
    #endif    
    #if use_centraleB == 1
        in_maj_b();
        user_loop();
        if(aig_on) aig_maj_b();
    #endif    
    fx_maj();
    led_maj();
    maj_alim_analog();
    pwm_maj();
    cli_maj();
    neo_maj();

    serial_maj();

    while(flag_62ms5==0) {}       
    flag_62ms5 = 0;
    maj_can();
    mouse_maj();    //second appel ds la periode de 125ms pour etre plus reactif // 62 car 125 trop court pour capter tous les fronts courts
    maj_srv_slow(); //calcul des deplacements lents des servos
    #if use_i2c == 1
        i2c_maj();  //ds cette seconde partie car peut prendre du temps
    #endif
}    


/* spare:

        //dcc.sstop();
        //dcc.low();
        //dcc.high();
        //dcc.restart();

  __asm__ __volatile__ ("sbi 5,5\n\t");  //digital 13 = PORTB bit5  //PIN_CLI
  __asm__ __volatile__ ("cbi 5,5\n\t");  //digital 13 = PORTB bit5  //PIN_CLI
  
  delayMicroseconds(10);

  //digitalWrite(PIN_IN  ,HIGH); pinMode(PIN_IN  , INPUT); digitalWrite(PIN_IN  ,HIGH); //pull up a activer apres pin_mode (pin_mode doit enlever la pull-up) !

*/  
