#!/usr/bin/python

#
# FDCC-NET-TCO
#
# Logiciel qui affiche un tco de fdcc_pc.py via le reseau pour la centrale free-dcc 2017
#
# fdcc_pc.py permet d'afficher des TCO.
# fdcc_net_tco.py:
# - se connecte a fdcc_pc.py
# - demande les infos pour créé le TCO demandé
# - demande toute les 250ms les mises à jours (couleurs et tailles) des éléments
# - transmet les clicks de la souris
#
# Si vous demandez le tco 5 alors le même tco que le tco 5 de fdcc_pc s'affichera !
# Le même tco peut fonctionner sur plusieurs PC
# La definition des tco est faite dans le fichier config_tco.txt charge par fdcc_pc
#
# Penser à configurer:
# - l'adresse IP du PC ou se trouve fdcc_pc. 
#    * Si les 2 programmes se trouvent sur le même PC,
#       vous pouvez mettre use_local à 1. Dans ce cas l'adresse IP spécifiée 
#       n'est pas utilisée. Le logiciel va la trouver tout seul
#       (vous pouvez aussi la spécifier et utiliser use_local à 0)
#    * Si les 2 programmes se trouvent sur des PC différent et reliés par le réseau,
#       vous devez mettre use_local à 1 et spécifier l'adresse IP
# - le port qu'a ouvert fdcc_pc pour les tco (1234 par defaut)
# - le numéro du tco que vous voulez (0-9)
#    * Si vous mettez -1, le programme vous demande quel tco vous voulez utiliser
#
# Il faut bien entendu lancer fdcc_pc avant de lancer fdcc_net_tco
# Vous pouvez lancer plusieurs tco
#
# Historique
# - 2017 jul 12: amelioration de l'affichage des tco -> ok
# - 2017 may 02: creation -> fonctionement ok
#

TITLE = "Free-DCC-2017-TCO-NET v20170712"

use_local     = 1
server_ip_adr = "10.20.30.40"
server_port   = 1234
tco_num       = -1

if(tco_num==-1):
    print("Quel TCO voulez-vous afficher (0-9) ? > ")
    tco_num = int(input())

    
    
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# IMPORT
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

import os
import time
import sys
import subprocess
import threading
import datetime
import socket
try:
    # for Python 3
    from tkinter import *
    print("Python 3.x interpreter detected")
except ImportError:
    # for Python2
    from Tkinter import *
    print("Python 2.x interpreter detected")
from math import *
import tkinter.messagebox

s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

    
    
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# MOUSE CALLBACK
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

mx = 0
my = 0
mok = 0
    
def callback_canvas_tco_mouse(event):
    global mx
    global my
    global mok
    mx = event.x
    my = event.y
    print("canvas tco clicked at:" + str(event.x) + "," + str (event.y))
    #msg = "click tco" + str(tco_num) + " "+ str(mx) + "," + str(my)    #click synchronise avec update maintenant
    #s.send(msg.encode())        
    mok = 1
    return
    
    
    
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# GUI management
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

top = Tk()  
top.title(TITLE)

my_canvas_tco = [ 0 for i in range(10)]   #on n'en utilise 1 mais on en cree 10 pour etre compatible avec le code de fdcc_pc

my_canvas_tco[tco_num] = tkinter.Canvas(top, bg="#5B9BD5", width = 200, height = 100) #petite taille pr ne pas prendre trop de memoire si pas utilise
my_canvas_tco[tco_num].grid(row = 0, column = 0)

my_canvas_tco[tco_num].bind("<Button-1>", callback_canvas_tco_mouse)
    
   
   
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# TCO FCT (95% du code de cette partie vient de fdcc_pc)
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

shape_list = [ 0 for i in range(10) ]
for i in range(10):
    shape_list[i] = []
    
class shape_entry():
    color = 0; old_color = 0; use_color = 0
    size  = 0; old_size  = 0; use_size  = 0
    widget = 0
    
def add_shape(tco, widget, color_, size_):
    global tco_shape    
    sh = shape_entry()
    sh.widget = widget
    sh.old_color = sh.color = color_
    sh.old_size = sh.size = size_
    shape_list[tco].append(sh)

#-----    
action_list = [ 0 for i in range(10) ]
for i in range(10):
    action_list[i] = []

class action_entry():   # uu: mettre des self
    x1 = 0
    y1 = 0
    x2 = 0
    y2 = 0
    var_name = ""
    cmd_name = ""
    
def add_action(tco, x1_, y1_, x2_, y2_, var_name, cmd_name):
    global action_list
    ##print("adding tco="+str(tco)+" x1="+str(x1_)+" y1="+str(y1_)+" x2="+str(x2_)+" y2="+str(y2_)+" var_name="+var_name+" cmd_name="+cmd_name)
    a = action_entry()
    a.x1 = x1_; a.y1 = y1_    
    a.x2 = x2_; a.y2 = y2_    
    a.var_name = var_name
    a.cmd_name = cmd_name
    action_list[tco].append(a)

#-----    
class color_entry():
    var_name = ""
    state = ""
    color = "#000000"
    color2 = "#000000"
    shape_ind = 0
    
color_list = [ 0 for i in range(10) ]
for i in range(10):
    color_list[i] = []
    
def add_color(tco, shape_ind_, var_name_, state_, color_):
    global color_list
    ##print("color tco="+str(tco)+" var_name="+var_name_+" state="+state_+" color="+color_)
    a = color_entry()
    a.var_name = var_name_
    a.state = state_
    a.color = color_
    a.shape_ind = shape_ind_
    color_list[tco].append(a)    

color2_list = [ 0 for i in range(10) ]
for i in range(10):
    color2_list[i] = []    

def add_color2(tco, shape_ind_ , var_name_, state_, color_, color2_):
    global color_list
    ##print("color tco="+str(tco)+" var_name="+var_name_+" state="+state_+" color="+color_)
    a = color_entry()
    a.var_name = var_name_
    a.state = state_
    a.color = color_
    a.color2 = color2_
    a.shape_ind = shape_ind_
    color2_list[tco].append(a)    
    
#-----    
class size_entry():
    var_name = ""
    state = ""
    size = 1
    size2 = 1
    widget = 0
    
size_list = [ 0 for i in range(10) ]
for i in range(10):
    size_list[i] = []
        
def add_size(tco, shape_ind_, var_name_, state_, size_):
    global color_list
    ##print("size tco="+str(tco)+" var_name="+var_name_+" state="+state_+" size="+str(size_))
    a = size_entry()
    a.var_name = var_name_
    a.state = state_
    a.size = size_
    a.shape_ind = shape_ind_
    size_list[tco].append(a)  

size2_list = [ 0 for i in range(10) ]
for i in range(10):
    size2_list[i] = []
        
def add_size2(tco, shape_ind_, var_name_, state_, size_, size2_):
    global color_list
    ##print("size tco="+str(tco)+" var_name="+var_name_+" state="+state_+" size="+str(size_))
    a = size_entry()
    a.var_name = var_name_
    a.state = state_
    a.size = size_
    a.size2 = size2_
    a.shape_ind = shape_ind_
    size2_list[tco].append(a)  

#-----    
class canton_entry():
    canton_num = 0
    widget = 0
    
canton_list = [ 0 for i in range(10) ]
for i in range(10):
    canton_list[i] = []

def add_canton(tco, widget_, canton):
    global canton_list
    a = canton_entry()
    a.widget = widget_
    a.canton_num = canton    
    canton_list[tco].append(a)
    

    
#-----

tco_config = "" #copie du fichier tco pour le transmettre aux tco distants           
gtco_x1 = 0    
gtco_y1 = 0    
gtco_x2 = 0    
gtco_y2 = 0    
def tco_load():

    global tco_shape
    global my_canvas_tco
    global gtco_x1; global gtco_y1; global gtco_x2; global gtco_y2 
    global tco_file_config    
    
    tc = 0 #tco current
    num_line=0

    lines = tco_config.split('\n')
    l = len(lines)
    for i in range(l):
        line = lines[i]
        ####print("line = " + line)
        
        if(1):  #juste pour l'indentation pour pouvoir re-utiliser le code de fdcc_pc
        
                num_line += 1
                line = line.rstrip("\n")
                if(line == ""):
                    continue
                if(line[0] == "#"):
                    continue
                #line = line.split("#")[0]       #remove comment
                line = line.rstrip()    
                ##print("line= " + str(num_line) + " > " + line)
                acmd = line.split()    #separateur blanc(s) ou tab
                lcmd = len(acmd)
            
                if(acmd[0] == "tco"):
                    tc = int(acmd[1])
                    continue

                if(tc != tco_num):
                    continue
                    
                if(acmd[0] == "grid"):
                    axy = acmd[1].split(",")
                    dx = int(axy[0]); dy = int(axy[1]);
                    gdx = int(axy[2]); gdy = int(axy[3]);
                    color_line = acmd[2]; color_fond = acmd[3]
                    my_canvas_tco[tc].config(bg = color_fond)
                    my_canvas_tco[tc].config(width = dx)
                    my_canvas_tco[tc].config(heigh = dy)
                    if(gdy):
                        nb = dy // gdy
                        for j in range (0, nb):
                            my_canvas_tco[tc].create_line(0, gdy * j, dx, gdy * j, fill = color_line, width = 1)
                    if(gdx):
                        nb = dx // gdx
                        for i in range (0,nb):
                            my_canvas_tco[tc].create_line(gdx * i, 0, gdx * i, dy, fill = color_line, width = 1)
                    continue
                    
                if(acmd[0] == "line"):
                    axy = acmd[1].split(",")
                    x1 = int(axy[0]); y1 = int(axy[1])
                    x2 = int(axy[2]); y2 = int(axy[3])
                    color = acmd[2]
                    size = acmd[3]
                    the_line = my_canvas_tco[tc].create_line(x1, y1, x2, y2, fill = color, width = size)
                    add_shape(tc, the_line, color, size)
                    continue
                    
                if(acmd[0] == "rect"):
                    axy = acmd[1].split(",")
                    x1 = int(axy[0]); y1 = int(axy[1])
                    x2 = int(axy[2]); y2 = int(axy[3])
                    gtco_x1 = x1; gtco_y1 = y1; gtco_x2 = x2; gtco_y2 = y2
                    color_border = acmd[2]; color = acmd[3]
                    size = acmd[4]
                    the_rect = my_canvas_tco[tc].create_rectangle(x1, y1, x2, y2, fill = color, outline = color_border, width = size)
                    add_shape(tc, the_rect, color, size)
                    continue
                    
                if(acmd[0] == "rectc"):
                    axy = acmd[1].split(",")
                    xc = int(axy[0]); yc = int(axy[1])
                    dx = int(axy[2]); dy = int(axy[3])
                    x1 = xc-dx; y1 = yc-dy
                    x2 = xc+dx; y2 = yc+dy              
                    gtco_x1 = x1; gtco_y1 = y1; gtco_x2 = x2; gtco_y2 = y2
                    color_border = acmd[2]; color = acmd[3]
                    size = acmd[4]
                    the_rect = my_canvas_tco[tc].create_rectangle(x1, y1, x2, y2, fill = color, outline = color_border, width = size)
                    add_shape(tc, the_rect, color, size)
                    continue

                if(acmd[0] == "ovalc"):
                    axy = acmd[1].split(",")
                    xc = int(axy[0]); yc = int(axy[1])
                    dx = int(axy[2]); dy = int(axy[3])
                    x1 = xc-dx; y1 = yc-dy
                    x2 = xc+dx; y2 = yc+dy              
                    gtco_x1 = x1; gtco_y1 = y1; gtco_x2 = x2; gtco_y2 = y2
                    color_border = acmd[2]; color = acmd[3]
                    size = acmd[4]
                    the_oval = my_canvas_tco[tc].create_oval(x1, y1, x2, y2, fill = color, outline = color_border, width = size)
                    add_shape(tc, the_oval, color, size)
                    continue

                if(acmd[0] == "txt"):
                    axy = acmd[1].split(",")
                    x = int(axy[0]); y = int(axy[1])
                    txt = acmd[2]
                    txt = txt.replace("\"", "")  #pour l'instant pas de blanc ds txt
                    color = acmd[3]
                    size = acmd[4]
                    zefont = ("Times New Roman", size, "bold")  #Helvetica #Courier
                    my_canvas_tco[tc].create_text(x, y, text = txt, font = zefont, fill = color, anchor = tkinter.W)
                    continue

                if(acmd[0] == "txt2"):
                    if(gtco_x2 > gtco_x1):
                        x = gtco_x2 + 2
                    else:
                        x = gtco_x1 + 2
                    y = (gtco_y1 + gtco_y2) // 2
                    txt = acmd[1]
                    txt = txt.replace("\"","")  #pour l'instant pas de blanc ds txt
                    color = acmd[2]
                    size = acmd[3]
                    zefont = ("Times New Roman", size, "bold")  #Helvetica #Courier
                    my_canvas_tco[tc].create_text(x, y, text = txt, font = zefont, fill = color, anchor = tkinter.W)
                    continue
                    
                if(acmd[0] == "txtc"):
                    axy = acmd[1].split(",")
                    x = int(axy[0]); y = int(axy[1])
                    txt = acmd[2]
                    txt = txt.replace("\"", "")  #pour l'instant pas de blanc ds txt
                    color = acmd[3]
                    size = acmd[4]
                    zefont = ("Times New Roman", size, "bold")
                    my_canvas_tco[tc].create_text(x, y, text = txt, font = zefont, fill = color)
                    continue 

                if(acmd[0] == "txtc2"):
                    x = (gtco_x1 + gtco_x2) // 2
                    y = (gtco_y1 + gtco_y2) // 2
                    txt = acmd[1]
                    txt = txt.replace("\"", "")  #pour l'instant pas de blanc ds txt
                    color = acmd[2]
                    size = acmd[3]
                    zefont = ("Times New Roman", size, "bold")
                    my_canvas_tco[tc].create_text(x, y, text = txt, font = zefont, fill = color)
                    continue 

                if(acmd[0] == "cantontxtc2"):
                    x = (gtco_x1 + gtco_x2) // 2
                    y = (gtco_y1 + gtco_y2) // 2
                    c = int(acmd[1])
                    txt = "c" + str(c) + ":!!!" 
                    color = acmd[2]
                    size = acmd[3]
                    zefont = ("Times New Roman", size, "bold")
                    the_txt = my_canvas_tco[tc].create_text(x, y, text = txt, font = zefont, fill = color)
                    add_canton(tc, the_txt, c)
                    continue 
                    
                # action xc,yc,dx,dy var[+,-,^]             
                if(acmd[0] == "action" or acmd[0] == "actionc"):
                    axy = acmd[1].split(",")
                    if(acmd[0] == "action"):
                        x1 = int(axy[0]); y1 = int(axy[1])
                        x2 = int(axy[2]); y2 = int(axy[3])
                    if(acmd[0] == "actionc"):
                        xc = int(axy[0]); yc = int(axy[1])
                        dx = int(axy[2]); dy = int(axy[3])
                        x1 = xc - dx; y1 = yc - dy
                        x2 = xc + dx; y2 = yc + dy
                    if(x1 > x2):
                        x  = x2; x1 = x2; x2 = x;
                    if(y1 > y2):
                        y = y2; y1 = y2; y2 = y;
                    var_name = acmd[2][0:-1]
                    var_action = acmd[2][-1]
                    add_action(tc, x1, y1, x2, y2, var_name, var_action) 
                    continue 

                if(acmd[0] == "action2" or acmd[0] == "actionc2"):
                    x1 = gtco_x1; y1 = gtco_y1
                    x2 = gtco_x2; y2 = gtco_y2
                    if(x1 > x2):
                        x = x2; x1 = x2; x2 = x;
                    if(y1 > y2):
                        y = y2; y1 = y2; y2 = y;
                    var_name = acmd[1][0:-1]
                    var_action = acmd[1][-1]
                    add_action(tc, x1, y1, x2, y2, var_name, var_action) 
                    continue

                # color [!]var color #s'applique au dernier line,oval,rect
                if(acmd[0] == "color"):
                    v = acmd[1]
                    if(v[0] == '!'):
                        var_state = "!"
                        var_name  = v[1:]
                    else:
                        var_state = ""
                        var_name  = v
                    add_color(tc, len(shape_list[tc])-1, var_name, var_state, acmd[2])
                    shape_list[tc][-1].use_color = 1
                    continue

                if(acmd[0] == "color2"):
                    v = acmd[1]
                    if(v[0] == '!'):
                        var_state = "!"
                        var_name  = v[1:]
                    else:
                        var_state = ""
                        var_name  = v
                    add_color2(tc, len(shape_list[tc])-1, var_name, var_state, acmd[2], acmd[3])
                    shape_list[tc][-1].use_color = 1
                    continue
                    
                # size [!]var size  #s'applique au dernier line,oval,rect  (size 0 = invisible) 
                if(acmd[0] == "size"):
                    v = acmd[1]
                    if(v[0] == '!'):
                        var_state = "!"
                        var_name  = v[1:]
                    else:
                        var_state = ""
                        var_name  = v
                    add_size(tc, len(shape_list[tc])-1, var_name, var_state, int(acmd[2]))
                    shape_list[tc][-1].use_size = 1
                    continue

                if(acmd[0] == "size2"):
                    v = acmd[1]
                    if(v[0] == '!'):
                        var_state = "!"
                        var_name  = v[1:]
                    else:
                        var_state = ""
                        var_name  = v
                    add_size2(tc, len(shape_list[tc])-1, var_name, var_state, int(acmd[2]), int(acmd[3]))
                    shape_list[tc][-1].use_size = 1
                    continue
                    
                if(acmd[0] == "end"):
                    break
                    
                print("TCO: UNKNOWN instruction: " + acmd[0])           
        
        # uu: on peut regenerer la shape list avec juste les widgets qui bougent pour plus de performances
                
        #except:
        #    print("TCO: ERROR line= " + str(num_line) + " > " + line)               
                

#update les couleurs et largeurs        
def tco_update(update_string):
    acmd = update_string.split()    #separateur blanc(s) ou tab
    lcmd = len(acmd)
    tco = tco_num

    au = 0
    horo = ""                
 
    j = 0
    while(j < lcmd):
        cmd = acmd[j]; j += 1
        #print("cmd = " + cmd)
        
        if(cmd == "color_size"):
            nb = len(shape_list[tco])
            for i in range(0, nb):
                if(shape_list[tco][i].use_color):
                    zecolor = acmd[j]; j += 1
                    if(shape_list[tco][i].color != zecolor):
                        shape_list[tco][i].color = zecolor
                        widget_ = shape_list[tco][i].widget
                        my_canvas_tco[tco].itemconfigure(widget_, fill = zecolor)
                if(shape_list[tco][i].use_size):
                    zesize  = int(acmd[j]); j += 1
                    if(shape_list[tco][i].size != zesize):
                        shape_list[tco][i].size = zesize
                        widget_ = shape_list[tco][i].widget
                        if(zesize == 0):
                            my_canvas_tco[tco].itemconfigure(widget_, state = 'hidden')
                        else:
                            my_canvas_tco[tco].itemconfigure(widget_, state = 'normal')        
                        my_canvas_tco[tco].itemconfigure(widget_, width = zesize)

        if(cmd == "canton"):
            nb = len(canton_list[tco])
            for i in range(0, nb):
                c  = canton_list[tco][i].canton_num
                t = acmd[j]; j += 1
                widget_ = canton_list[tco][i].widget
                my_canvas_tco[tco].itemconfigure(widget_, text = t)

        if(cmd == "au"):
            au = int(acmd[j]); j += 1
                
        if(cmd == "horo"):
            horo = acmd[j]; j += 1
                    
    sz = TITLE
    if(au):
        sz += " ARRET D'URGENCE"
    sz += " "    
    sz += horo
    top.title(sz)

    return
    

    
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# NETWORK FCT
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

#s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

def net_connect(): 
    if(use_local):
        adr = socket.gethostbyname(socket.gethostname())
    else:
        adr = server_ip_adr   

    s.connect((adr, server_port))
    print("NETWORK: connected")
    welcome = s.recv(1024).decode()
    print("NETWORK: server string: \"" + welcome + "\"")
    s.send("tco netv2".encode())
    return

net_connect()   

def net_disconnect():
    s.close()
    return
    
def net_update():        
    # send msg
    msg = "wazza"
    print("NETWORK: send: " + msg)
    s.send(msg.encode())        
    return 

    

#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# CALLBACKS
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

def tco_init():

    global tco_config

    msg = "init tco" + str(tco_num)
    s.send(msg.encode())        
    ##print("TX: " + msg)

    msg = s.recv(1024).decode()
    ##print("RX: " + msg)
    size = int(msg)

    msg = "ok"
    s.send(msg.encode())        
    ##print("TX: " + msg)
    
    current_size = 0
    while(current_size < size):
        msg = s.recv(1024).decode()
        ##print("RX: " + msg)
        tco_config += msg
        current_size += len(msg)
        #print("current_size=" + str(current_size))
        
    #print("TOTAL-RX: " + tco_config)

    msg = "ok"
    s.send(msg.encode())        
    ##print("TX: " + msg)
    
    tco_load()
    
    return

tco_init()

   

#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# THREAD callback
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

def tic_cb():
    global mok
    ##print("tic cb")
    
    update_string = ""
    
    msg = "update tco" + str(tco_num)
    s.send(msg.encode())        
    ##print("TX: " + msg)

    msg = s.recv(1024).decode()
    ##print("RX: " + msg)
    size = int(msg)

    msg = "ok"
    s.send(msg.encode())        
    ##print("TX: " + msg)
    
    current_size = 0
    while(current_size < size):
        msg = s.recv(1024).decode()
        ##print("RX: " + msg)
        update_string += msg
        current_size += len(msg)
        #print("current_size=" + str(current_size))
        
    #print("TOTAL-UPDATE-RX: " + update_string)

    msg = "ok"
    s.send(msg.encode())        
    ##print("TX: " + msg)
    
    tco_update(update_string)
    
    if(mok):
        mok=0
        msg = "click tco" + str(tco_num) + " " + str(mx) + "," + str(my)
        s.send(msg.encode())        

    return

    
    
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/
# MAIN
#/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/\/

ze_cpt=0
real_time_err_cpt = 0
isr_on = 1

def tic_isr_fct():      #uu: refaire a la mode lwa
  global ze_cpt
  global real_time_err_cpt
  global isr_on
  
  if(isr_on == 0):
      return
  
  t1=time.time()
  tic_cb()
  t2=time.time()
  
  dt=int(1000*(t2-t1))
  dt2=250-dt
  if(dt2<0):
      dt2=0
  if(dt2>250):
      dt2=250
  if(dt>250):
      real_time_err_cpt += 1
      
  print("cpt=" + str(ze_cpt) + " dt=" + str(dt) + " freedt=" + str(dt2) + " rterr=" + str(real_time_err_cpt))
  threading.Timer(float(dt2/1000), tic_isr_fct).start()
  ze_cpt+=1
  return

time.sleep(1)
  
tic_isr_fct()
    
top.mainloop()

isr_on = 0
print("ByeBye")
time.sleep(1)



