!!
    RFO_SOURIS.BAS
    
    Ce programme est une souris TCP/IP pour Free-DCC-PC code en RFO basic
    pour les telephones et tablettes Android
    
    Historique:
    2017-06-20: Ulysse Delmas-Begue: creation
    
    Notes:
    l'appuie sur au fait deconnecter le serveur !!!
    
    Licence: GPLv2  
!!    

!***************** CONFIGURATION ************************

! Adresse du serveur FDCC-PC 
! ex: "192.168.0.100"
! ex: "" (Dans ce cas le programme demande a l'utilisateur d'indiquer l'adresse IP)
ip$ = "192.168.0.100"

! Port du serveur FDCC-PC 
! ex: 1234 (port par defaut de FDCC-PC)
! ex: 0 (Dans ce cas le programme demande a l'utilisateur d'indiquer le port TCP)
port = 1234

! Adresse de la locomotive 
! ex: 3
! ex: 0 (Dans ce cas le programme demande a l'utilisateur d'indiquer l'adresse DCC)
dcc_adr = 3

IF(ip$ = "") THEN INPUT "Adresse IP ?", ip$
    
IF(port = 0) THEN INPUT "Port TCP ?", port, 1080

IF(dcc_adr = 0) THEN INPUT "Loco ?", dcc_adr, 3
IF(dcc_adr >= 10.0) THEN n = 2 else n = 1
dcc_adr$ = left$(str$(dcc_adr), n)    


!***************** OUVERTURE DE LA LIAISON TCP/IP ************************

! Connect to FDCC-PC server
SOCKET.CLIENT.CONNECT ip$, port
PRINT "Connected"

! Wait after server welcome message
! or time out after 10 seconds
maxclock = CLOCK() + 10000
DO
    SOCKET.CLIENT.READ.READY flag
    IF CLOCK() > maxclock
        PRINT "ERR: Pas de message de bienvenu du serveur FDCC-PC"
        END
    ENDIF
UNTIL flag
SOCKET.CLIENT.READ.LINE msg$
PRINT msg$
msg$ = "cabine netv1"
SOCKET.CLIENT.WRITE.LINE msg$
pause 1000
! INPUT "MSG >", msg$


!***************** VARIABLES DE LA SOURIS ************************

sens = 1
vit = 0
vit$ = "0"
old_au = 0
au = 0
DIM fct[5]
FOR i = 1 TO 5
    fct[i] = 0
NEXT i
!array.load fct[] = 0, 0, 0, 0, 0
old_touched = 0
touched = 0
cmess$ = ""
old_cmess$ = ""
old_au_red = 0
au_red = 0


!***************** CREATION DE L'INTERFACE GRAPHIQUE ************************

! parametrage du graphique

GR.OPEN 255, 255, 255, 255
GR.ORIENTATION -1 % -1=auto 0=paysage 1=portrait 2=paysage_inv 3=portrait_inv
GR.SCREEN w , h
h = 600
GR.TEXT.ALIGN 2 %center
GR.TEXT.SIZE h / 20

! creation de quelques pinceaux
! (ne pas faire le stroke car c'est fill ou stroke !)

GR.COLOR 255, 0, 255, 0, 1 %fill
GR.PAINT.GET p_paint_green

GR.COLOR 255, 255, 0, 0, 1 %fill
GR.PAINT.GET p_paint_red

GR.COLOR 255, 136, 136, 136, 1 %fill
GR.PAINT.GET p_paint_grey

GR.COLOR 255, 240, 240, 0, 1 %fill
GR.PAINT.GET p_paint_yellow

GR.COLOR 255, 255, 136, 136, 1 %fill
GR.PAINT.GET p_paint_sens_0

GR.COLOR 255, 136, 136, 255, 1 %fill
GR.PAINT.GET p_paint_sens_1

! Widgets

    ! rectangle de fond
    GR.COLOR 255, 91, 155, 213, 1 %fill
    GR.RECT p_rectfond, 0, 0, 300, 600

    ! creation label dcc adr
    GR.COLOR 255, 0, 0, 0, 1 %fill
    GR.TEXT.DRAW p_txtdccadr, 25, 50, "$" + dcc_adr$

    ! creation label cran
    GR.COLOR 255, 0, 0, 0, 1 %fill
    GR.TEXT.DRAW p_txtvit, 100, 50, "+0"

    ! creation potentiometre
    GR.COLOR 255, 192,192, 192, 1 %fill
    GR.RECT p_rectglissiere, 100 - 20, 350 - 28 * 10, 100 + 20, 350
    GR.COLOR 255, 0, 0, 0, 0 %border
    GR.RECT p_r, 100 - 20, 350 - 28 * 10, 100 + 20, 350
    GR.COLOR 255, 255, 0, 0, 1 %fill
    GR.RECT p_rectcursor, 100 - 50, 350 - 10, 100 + 50, 350 + 10
    GR.COLOR 255, 0, 0, 0, 0 %border
    GR.RECT p_rcursor, 100 - 50, 350 - 10, 100 + 50, 350 + 10

    ! creation bouton sens
    GR.COLOR 255, 136, 136, 255, 1 %fill
    GR.RECT p_rectsens, 100 - 30, 450 - 30, 100 + 30, 450 + 30
    GR.COLOR 255, 0, 0, 0, 0 %cursor
    GR.RECT p_r, 100 - 30, 450 - 30, 100 + 30, 450 + 30
    GR.COLOR 255, 0, 0, 0, 1 %fill
    GR.TEXT.DRAW p_txtsens, 100, 450, "+"

    ! creation bouton AU
    GR.COLOR 255, 136, 136, 136, 1 %fill
    GR.RECT p_rectau, 200 - 30, 450 - 30, 200 + 30, 450 + 30
    GR.COLOR 255, 0, 0, 0, 0 %cursor
    GR.RECT p_r, 200 - 30, 450 - 30, 200 + 30, 450 + 30
    GR.TEXT.ALIGN 2 %center
    GR.TEXT.SIZE h / 20
    GR.COLOR 255, 0, 0, 0, 1 %fill
    GR.TEXT.DRAW p_txtau, 200, 450, "AU"

    ! creation bouton fct    
    DIM p_rectfct[5]
    FOR i = 1 TO 5
        GR.COLOR 255, 136, 136, 136, 1 %fill
        GR.RECT p_rectfct[i], 200 - 30, 70 * i - 30, 200 + 30, 70 * i + 30
        GR.COLOR 255, 0, 0, 0, 0 %cursor
        GR.RECT p_r, 200 - 30, 70 * i - 30, 200 + 30, 70 * i + 30
        GR.COLOR 255, 0, 0, 0, 1 %fill
        GR.TEXT.DRAW p_txtau, 200, 70*i, left$(str$(i-1),1)
    NEXT i

    GR.RENDER


!***************** MISE A JOUR L'INTERFACE GRAPHIQUE ************************

cpt = 0
tx_ok = 0
DO
    pause 50
    old_touched = touched
    GR.TOUCH touched, tx, ty
    cpt += 1
    IF(cpt = 10) THEN cpt = 0
    tx_ok = BXOR(tx_ok, 1) %transmettre une fois/2 (toutes les 100ms)
    
    ! APPUI CONSTANT
    IF(touched) THEN
        !d_u.continue
      
        ! Gestion du potentiometre
        IF(tx >= 50 & tx <= 150 & ty < 370) THEN
            vit = (350 - ty) / 10
            IF(vit < 0 ) THEN vit=0
            IF(vit > 28) THEN vit=28
            IF(vit >= 10.0) THEN n = 2 else n = 1
            vit$ = left$(str$(vit), n)
	    IF(vit = 0) THEN vit$ = "0"
            y = 350 - 10 * vit
            yh = y - 10
            yl = y + 10
            GR.MODIFY p_rectcursor, "top"   , yh
            GR.MODIFY p_rectcursor, "bottom", yl
            GR.MODIFY p_rcursor   , "top"   , yh
            GR.MODIFY p_rcursor   , "bottom", yl
            IF(sens = 1) THEN vvit$ = "+" ELSE vvit$ = "-"
            vvit$ += vit$
            GR.MODIFY p_txtvit    , "text"  , vvit$
            GR.RENDER
        ENDIF
      
    ENDIF
    
    ! APPUI FRONT
    IF(old_touched = 0 & touched = 1) THEN
    
        ! Gestion du bouton sens
        IF(tx >= 50 & tx <= 150 & ty > 450 - 30 & ty < 450 + 30) THEN
            sens = BXOR(sens, 1)
            IF(sens = 1) THEN
	        sens$ = "+"
		GR.MODIFY p_rectsens, "paint", p_paint_sens_1
            ELSE
		sens$ = "-"
		GR.MODIFY p_rectsens, "paint", p_paint_sens_0
	    ENDIF
            GR.MODIFY p_txtsens, "text", sens$
            GR.RENDER
        ENDIF
      
        ! Gestion du bouton AU
        IF(tx >= 200 - 30 & tx <= 200 + 30 & ty > 450 - 30 & ty < 450 + 30) THEN
            au = BXOR(au, 1)
        ENDIF
      
        ! Gestion des boutons des fonctions
        FOR i = 1 to 5 
            IF(tx >= 200 - 30 & tx <= 200 + 30 & ty > 70 * i - 30 & ty < 70 * i + 30) THEN
	        fct[i] = BXOR(fct[i], 1)
	        IF(fct[i] = 0) THEN
                    GR.MODIFY p_rectfct[i], "paint", p_paint_grey 
		ELSE
		    GR.MODIFY p_rectfct[i], "paint", p_paint_yellow
	        ENDIF
                GR.RENDER
            ENDIF
        NEXT i

	! Gestion du changement de locomotive
        IF(tx <= 30 & ty < 30) THEN
	    GR.FRONT 0
	    DO
                INPUT "Loco ?", dcc_adr, dcc_adr
                IF(dcc_adr >= 10.0) THEN n = 2 ELSE n = 1
                dcc_adr$ = left$(str$(dcc_adr), n)    
	    UNTIL(dcc_adr >= 1 & dcc_adr <= 50)
            GR.FRONT 1
            GR.MODIFY p_txtdccadr, "text", "$" + dcc_adr$
	    GR.RENDER
	ENDIF
	
    ENDIF 

    ! Gestion du clignotement du bouton AU
    IF(au = 1 & cpt < 5) THEN
        au_red = 1
    ELSE
        au_red = 0
    ENDIF
    IF(au_red <> old_au_red) THEN
        old_au_red = au_red
        IF(au_red = 1) THEN	
            GR.MODIFY p_rectau, "paint", p_paint_red
        ELSE
            GR.MODIFY p_rectau, "paint", p_paint_grey
	ENDIF
        GR.RENDER
    ENDIF
    
    
!***************** TRANSMISSION DE LA COMMANDE ************************
    !ex de cmd: cmess$ = "a3 au0 s+ f0+ f1- f2- f3- f4- v"
    
    IF(tx_ok) THEN
        cmess$ = "a"
        cmess$ += dcc_adr$
    
        IF(old_au <> au) THEN
            IF(au = 0) THEN
	        cmess$ += " au0"
    	    ELSE
	        cmess$ += " au1"
	    ENDIF
	    old_au = au
        ENDIF
    
        cmess$ += " v"
        cmess$ += vit$
    
        IF(sens = 1) THEN
            cmess$ += " s+"
        ELSE
            cmess$ += " s-"
        ENDIF
    
        FOR i = 1 TO 5 
            cmess$ += " f"
	    cmess$ += left$(str$(i-1),1)
            IF(fct[i]=0) THEN
                cmess$ += "-"
            ELSE
                cmess$ += "+"
            ENDIF
        NEXT i
    
        IF(cmess$ <> old_cmess$) THEN
            !GR.FRONT 0
            !PRINT cmess$
            !PAUSE 2000
            !GR.FRONT 1
	    !GR.RENDER
            SOCKET.CLIENT.WRITE.LINE cmess$
        ENDIF
        old_cmess$ = cmess$
    
    ENDIF

    GR.RENDER  %au cas ou l'orientation change
    
UNTIL(0)



 
 
 
